
function formatBytes(value, digits) {
    var kBytes = Math.ceil(value / 1024);
    return (kBytes / 1024).toFixed(digits === undefined ? 1 : digits);
}

function formatMilliseconds(ms) {
    return normalizeDuration(ms / 1000).readableWithUnits;
}

// code from map connector Units.qml
function normalizeDuration(seconds) {
    var readableWithoutUnits = "";
    var readableWithUnits = "";
    var unit = "";

    if (seconds < 60) {
        //readableWithoutUnits = Math.round(seconds);
        unit = ""//qsTranslate("Maps", "qtn_maps_unit_less_than_minute");
    } else if (seconds < 3600) {
        readableWithoutUnits = Math.round(seconds / 60);
        unit = qsTranslate("Maps", "qtn_maps_unit_minute");
    } else if (seconds < 36000) {
        var hours = Math.round(seconds / 3600);
        var minutes = Math.round((seconds % 3600) / 60);
        readableWithoutUnits = "%1:%2".arg(hours).arg(minutes < 10 ? "0" + minutes : minutes);
        unit = qsTranslate("Maps", "qtn_maps_unit_hour");
    } else {
        readableWithoutUnits = Math.round(seconds / 3600);
        unit = qsTranslate("Maps", "qtn_maps_unit_hour");
    }

    return {
        original: seconds,
        readableWithUnits: qsTranslate("Maps", "qtn_maps_value_with_unit").arg(readableWithoutUnits).arg(unit),
        readableWithoutUnits: readableWithoutUnits,
        unit: unit
    }
}

var _BASE_URL_ = odmlBaseURI;
function getUrlToDownload(shortMode, region) {
    if (region && region.downloadUrl) {
        if (shortMode) {
            return _BASE_URL_ + region.downloadUrl;
        } else {
            return _BASE_URL_ + region.downloadUrl + "?" + region.id;
        }
    } else {
        return "";
    }
}
