import QtQuick 1.0

import com.nokia.meego 1.0

import ovi.connector.places 1.0

import "OfflineMapLogic.js" as Logic

Page {
    objectName: "continentListPage"
    anchors.fill: parent;
    tools: ToolBarLayout {
        ToolIcon {
            iconId: "icon-m-toolbar-back"
            anchors.left: parent.left
            onClicked: pageStack.pop()
        }
    }

    Rectangle {
        anchors.fill: parent
        color: "#f0f1f2"
    }

    OdmlHeader {
        id: header
        title: qsTranslate("Maps", "qtn_maps_more_offlinemaps_addmaps")
    }

    PlacesCommonList { //was ListView
        id: availableList
        objectName: "availableList"

        anchors {left: parent.left; right: parent.right; top: header.bottom; bottom: parent.bottom; topMargin: 20 } //LO: topMargin 20 is needed to not hide the OdmlHeader border
        clip: true
        model: addMapModel

        itemDelegate: OfflineMapListDelegate { //was delegate //OfflineMapListDelegate
            objectName: "offlineMapListDelegate_" + index
            name: modelData.localizedName || modelData.name
            installed: modelData.installed
            hasChildren: modelData.children.length > 0
            error: modelData.error || false
            onItemClicked: Logic.processItemSelected(addMapModel.get(index));
        }
    }

    ScrollDecorator {
        flickableItem: availableList
    }

    ListModel { id: addMapModel }

    Component {
        id: removePage
        RemovePage {}
    }

    Component.onCompleted: {
        Logic.getFirstLevel({
            type: "continent",
            model: addMapModel,
            availableRegions: mapCatalog.availableRegions,
            installedRegions: mapCatalog.installedRegions,
            showInstalledRegions: false
        });
    }
}
