var BASE_URL = odmlBaseURI;
var VERSION = "v3.06";
var _INTERNAL_VERSION_ = null;

var xhr;

function checkIfAnyDataAvailable() {
    return mapCatalog.catalogFilesExist() && mapCatalog.availableRegions.length > 0;
}

function downloadCatalogData() {
    var fixedPluginMapVersion = fixMapVersion();
    if (fixedPluginMapVersion == "4294967295.4294967295.4294967295.4294967295" || fixedPluginMapVersion == "00.00.00.00") {
        log.info("MOS still does not have the map version, will try to get it online...")
        getMapVersion(handleMapVersionReceived);
    } else {
        log.info("MOS has the map version, will use it :: " + fixedPluginMapVersion);
        handleMapVersionReceived(fixedPluginMapVersion);
    }
}

function getCurrentMapVersion() {
    return _INTERNAL_VERSION_ || fixMapVersion();
}

function fixMapVersion() {
    var fixedVersionString = "";

    var fixedVersionParts = MapsPlugin.mapVersion.split(".");
    fixedVersionString += new String(fixedVersionParts[0]).length == 1? ("0" + fixedVersionParts[0]) : fixedVersionParts[0];
    fixedVersionString += ".";
    fixedVersionString += new String(fixedVersionParts[1]).length == 1? ("0" + fixedVersionParts[1]) : fixedVersionParts[1];
    fixedVersionString += ".";
    fixedVersionString += new String(fixedVersionParts[2]).length == 1? ("0" + fixedVersionParts[2]) : fixedVersionParts[2];
    fixedVersionString += ".";
    fixedVersionString += new String(fixedVersionParts[3]).length == 1? ("0" + fixedVersionParts[3]) : fixedVersionParts[3];

    return fixedVersionString;
}

function handleMapVersionReceived(version, fileSavePrefix) {
    _INTERNAL_VERSION_ = version;

    downloadConfigurationXMLs(version, fileSavePrefix);
}

function downloadCityIndexList(link) {
    var tmp, url, id, found = false;
    for (var i = 0; i < downloadManager.requests.length; i++) {
        tmp = downloadManager.requests[i];
        url = tmp.url;
        id = tmp.id;
        if (id == -3 && url == BASE_URL + link) {
            found = true;
            break;
        }
    }

    if (!found) {
        log.info("..... will try to download \"" + BASE_URL + link + "\" to \"" + mapCatalog.mapBaseDirectory + "/diskcache" + "/ClientIndex/" + "\" ....");
        log.info("..... Resuming odml...");
        downloadManager.resume();
        downloadManager.download(-3, BASE_URL + link, mapCatalog.mapBaseDirectory +  "/diskcache" + "/ClientIndex/", true);
    } else {
        log.info("..... will NOT try to download \"" + BASE_URL + link + "\" to \"" + mapCatalog.mapBaseDirectory + "/diskcache" + "/ClientIndex/" + "\" ....");
    }
}

function downloadConfigurationXMLs(version) {
    log.trace("..... will try to download \"" + BASE_URL + "maploaderzip-" + version + "/catalog-" + version + ".xml" + "\" to \"" + mapCatalog.mapLoaderDirectory + "/" + "\" ....");
    log.trace("..... will try to download \"" + BASE_URL + "maploaderzip-" + version + "/regionname-lang-" + appState.locale.digitCode + ".xml" + "\" to \"" + mapCatalog.mapLoaderDirectory + "/" + "\" ....");
    log.info("..... Resuming odml...");
    downloadManager.resume();
    downloadManager.download(-1, BASE_URL + "maploaderzip-" + version + "/catalog-" + version + ".xml", mapCatalog.mapLoaderDirectory + "/", false);
    downloadManager.download(-2, BASE_URL + "maploaderzip-" + version + "/regionname-lang-" + appState.locale.digitCode + ".xml", mapCatalog.mapLoaderDirectory + "/", false);
}

function checkIfCurrentInstalledMapVersionIsChina() {
    var parts = mapCatalog.installedMapsVersion.split(".");
    if (parts.length == 4 && parts[3].length == 2) {
        return true;
    } else {
        return false;
    }
}

function getMapVersion(callback) {
    var alreadyInChina = checkIfCurrentInstalledMapVersionIsChina();
    var noInstalledMapData = !mapCatalog.installedMapsVersion;

    xhr = new XMLHttpRequest();

    xhr.open("GET", BASE_URL + "versions/versions.xml", true);
    xhr.onreadystatechange = function() {
        if (xhr.readyState == 4 && xhr.responseText) {
            var mapVersion, mapRestVersion;
            var node, subNode;
            var root = xhr.responseXML.documentElement;
            if (root.nodeName == "versions") {
                for (var i = 0; i < root.childNodes.length; i++) {
                    node = root.childNodes[i];
                    if (node && node.nodeName == "version") {
                        for (var j = 0; j < node.childNodes.length; j++) {
                            subNode = node.childNodes[j];
                            if (subNode && subNode.nodeName == "client") {
                                if (subNode.firstChild && subNode.firstChild.nodeValue == VERSION) {
                                    var id = node.attributes.id && node.attributes.id.nodeValue;
                                    var rest = node.attributes.rest && node.attributes.rest.nodeValue;

                                    if (rest) {
                                        var foundRest = false;

                                        if (alreadyInChina) {
                                            foundRest = true;
                                        } else if (noInstalledMapData) {
                                            var restParts = rest.split(";");

                                            for (var k = 0; k < restParts.length; k++) {
                                                if (restParts[k] == appState.currentMobileNetworkCode) {
                                                    foundRest = true;
                                                    break;
                                                }
                                            }
                                        }

                                        if (foundRest) {
                                            if (!mapRestVersion || mapRestVersion < id) {
                                                mapRestVersion = id;
                                            }
                                        }
                                    } else {
                                        if (!mapVersion || mapVersion < id) {
                                            mapVersion = id;
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }

            if (callback) {
                callback(mapRestVersion? mapRestVersion : mapVersion);
            }
        } else if (xhr.readyState == 1 || xhr.readyState == 4) {
            if (callback) {
                callback(fixMapVersion());
            }
        }
    };
    xhr.send();
}

function getCityIndexDataByRegionId(region, version, callback) {
    xhr = new XMLHttpRequest();

    log.info("*** downloading city index :: " + BASE_URL + "maploaderzip-" + version + "/cityindex-" + version + ".xml")

    xhr.open("GET", BASE_URL + "maploaderzip-" + version + "/cityindex-" + version + ".xml", true);
    xhr.onreadystatechange = function() {
        if (xhr.readyState == 4 && xhr.responseText) {
            var cityIndexData;
            var node, subNode;
            var root = xhr.responseXML.documentElement;
            if (root.nodeName == "Package" && root.attributes.Name.nodeValue == "cityindex-" + version) {
                for (var i = 0; i < root.childNodes.length && !cityIndexData; i++) {
                    node = root.childNodes[i];
                    if (node && node.nodeName == "File") {
                        for (var j = 0; j < node.childNodes.length; j++) {
                            subNode = node.childNodes[j];
                            if (subNode.nodeName == "Region" && subNode.firstChild && subNode.firstChild.nodeValue == region) {
                                cityIndexData = {};
                                for (var k = 0; k < node.attributes.length; k++) {
                                    cityIndexData[node.attributes[k].nodeName] = node.attributes[k].nodeValue;
                                }

                                break;
                            }
                        }
                    }
                }
            }

            if (callback) {
                callback(cityIndexData);
            }
        } else if (xhr.readyState == 1 || xhr.readyState == 4) {
            if (callback) {
                callback();
            }
        }
    };
    xhr.send();
}

function ensureCatalogData() {
    var result = 0;

    if (!checkIfAnyDataAvailable()) {
        if (mainscreen.onlineMode) {
            offlineMapsPage.preventListeningForRequestChanges = true;

            result = 0;

            log.info("************************* allow GPRS")
            downloadManager.allowGprsConnection(true);

            downloadCatalogData();
        } else {
            result = -1;
        }
    } else {
        offlineMapsPage.preventListeningForRequestChanges = false;

        result = 1;

        log.info("************************* NOT allow GPRS")
        downloadManager.allowGprsConnection(false);
    }

    return result;
}
