import QtQuick 1.0

import com.nokia.meego 1.0

import ovi.connector 1.0

import "DownloadTools.js" as Tools

CommonItemDelegate {
    id: item
    property alias name: nameField.text
    property string size
    property string checkState
    onCheckStateChanged: {
        if (item.checkState == "checked") {
            checkboxField.checked = true;
        } else if (item.checkState == "unchecked") {
            checkboxField.checked = false;
        }
    }

    signal itemClicked(int index, bool checked)

    MapsText {
        state: "listNormal"
        id: nameField

        elide: Text.ElideMiddle

        width: parent.width / 2 - 25
        anchors {
            left: parent.left
            leftMargin: 20
            verticalCenter: parent.verticalCenter
        }
    }

    MapsText {
        state: "listNormal"
        id: sizeField

        text: Tools.formatBytes(item.size) + "Mb"

        elide: Text.ElideMiddle
        width: parent.width / 2 - 25
        horizontalAlignment: Text.AlignRight

        anchors {
            right: parent.right
            rightMargin: 90
            verticalCenter: parent.verticalCenter
        }
    }

    CheckBox {
        id: checkboxField

        checked: item.checkState == "checked"

        anchors {
            right: parent.right
            rightMargin: 20
            verticalCenter: parent.verticalCenter
        }

        onClicked: {
            checkboxField.checked = checkboxField.checked;
            item.itemClicked(index, checkboxField.checked);
        }
    }
}
