import QtQuick 1.0

import com.nokia.meego 1.0

Rectangle {
    id: mainscreen

    height: 480
    width: 854
    color: "#f0f1f2"
    visible: true


    ToolBar {
        id: tb;
        anchors.bottom: parent.bottom;
        tools: TabBarLayout {
            ToolButton {
                text: pageStack.depth === 1 ? "Quit" : "Back"

                onClicked: {
                    if (pageStack.depth === 1) {
                        Qt.quit();
                    } else {
                        pageStack.pop();
                    }
                }
            }
        }
    }

    PageStack {
        id: pageStack
        anchors {left:parent.left; right: parent.right; top: parent.top; bottom: tb.top }
    }

    OfflineMaps {
        id: offlineMaps
    }

    Component.onCompleted: {
        pageStack.push(offlineMaps)
    }
}
