import QtQuick 1.0
import AnalyticsNokia 1.0

Item {
    id: analyticsServiceMaps
    property variant sessionIMEI: nacSessionIMEI
    property variant sessionUUID: nacSessionUUID
    property string agentName
    property string agentVersion

    AnalyticsApplication {
        id: nacApplicationIMEI
        agentName: analyticsServiceMaps.agentName
        agentVersion: analyticsServiceMaps.agentVersion
    }

    AnalyticsSession {
        id: nacSessionIMEI
        sessionId: "mapsNacSessionIMEI"
        agentName: analyticsServiceMaps.agentName
        bearerReporting: true
    }

    AnalyticsApplication {
        id: nacApplicationUUID
        agentName: analyticsServiceMaps.agentName + ".anonymous"
        agentVersion: analyticsServiceMaps.agentVersion
        anonymous: true
    }

    AnalyticsSession {
        id: nacSessionUUID
        sessionId: "mapsNacSessionUUID"
        agentName: analyticsServiceMaps.agentName + ".anonymous"
    }

    function init() {
        nacSessionIMEI.open();
        log.trace("--- [NAC] Analytics session started (IMEI) ==>");
        nacSessionUUID.open();
        log.trace("--- [NAC] Analytics session started (UUID) ==>");
    }

    function destruct() {
        nacSessionIMEI.close(AnalyticsSession.AppExitCloseReason);
        log.trace("--- [NAC] analytics session closed (IMEI).")
        nacSessionUUID.close(AnalyticsSession.AppExitCloseReason);
        log.trace("--- [NAC] analytics session closed (UUID).")
    }

    Component.onCompleted: {
        init();
        log.trace("--- [NAC] Component init completed ---\n- agentName:  " + agentName + "\n- agentVersion: " + agentVersion)
    }
}
