import QtQuick 1.0

import com.nokia.meego 1.0

Label {
    id: mapsText
    platformStyle: LabelStyle {
        id: textStyle
        textColor: primaryColor
        fontPixelSize: 22
    }
    elide: "ElideRight"
    font.weight: Font.Light

    property string primaryColor: "#191919"
    property string secondaryColor: "#8c8c8c"
    property string highlightColor: "#4591ff"
    property string warningColor: "#8b0000"

    states: [
        State {
            name: "smallerText"
            PropertyChanges {
                target: textStyle
                fontPixelSize: 18
                textColor: secondaryColor
            }
        },
        State {
            name: "listSmall"
            PropertyChanges {
                target: textStyle
                textColor: secondaryColor
            }
        },
        State {
            name: "listSmallLight"
            PropertyChanges {
                target: textStyle
                textColor: secondaryColor
            }
            PropertyChanges {
                target: mapsText
                font.weight: Font.Light
            }
        },
        State {
            name: "listNormal"
            PropertyChanges {
                target: textStyle
                fontPixelSize: 24
            }
        },
        State {
            name: "listNormalBold"
            PropertyChanges {
                target: textStyle
                fontPixelSize: 24
            }
            PropertyChanges {
                target: mapsText
                font.weight: Font.Bold
            }
        },
        State {
            name: "listNormalWrap"
            PropertyChanges {
                target: textStyle
                fontPixelSize: 24
            }
            PropertyChanges {
                target: mapsText
                wrapMode: Text.WordWrap
            }
        },
        State {
            name: "normalWrap"
            PropertyChanges {
                target: textStyle
                fontPixelSize: 24
            }
            PropertyChanges {
                target: mapsText
                wrapMode: Text.Wrap;
                elide: "ElideNone"
            }
        },
        State {
            name: "smallLight"
            PropertyChanges {
                target: textStyle
                fontPixelSize: 20
                textColor: secondaryColor
            }
            PropertyChanges {
                target: mapsText
                font.weight: Font.Light
            }
        },
        State {
            name: "normalWrapRed"
            PropertyChanges {
                target: textStyle
                fontPixelSize: 24
                textColor: warningColor
            }
            PropertyChanges {
                target: mapsText
                wrapMode: Text.Wrap;
                elide: "ElideNone"
            }
        },
        State {
            name: "listLarge"
            PropertyChanges {
                target: textStyle
                fontPixelSize: 26
            }
            PropertyChanges {
                target: mapsText
                font.weight: Font.Bold
            }
        },
        State {
            name: "listHeader"
            PropertyChanges {
                target: textStyle
                fontPixelSize: 18
            }
            PropertyChanges {
                target: mapsText
                font.weight: Font.Bold
            }
        },
        State {
            name: "listSmallBold"
            PropertyChanges {
                target: textStyle
                fontPixelSize: 22
            }
            PropertyChanges {
                target: mapsText
                font.weight: Font.Bold
            }
        },
        State {
            name: "listLightWrap"
            PropertyChanges {
                target: textStyle
                fontPixelSize: 22
            }
            PropertyChanges {
                target: mapsText
                font.weight: Font.Light
                wrapMode: Text.WordWrap
            }
        }

    ]
}
