import QtQuick 1.0

Item {
    id: roundedCorner
    property string singleBackgroundColor: parent.backgroundColor ? parent.backgroundColor : "#f0f1f2"

    width:  10
    height: 10
    clip: true
    smooth: true
    anchors.left: parent.left
    anchors.top:  parent.top

    Rectangle {
        id: baseRect
        color: "black"
        height: 20
        width:  20
        clip: true
        anchors.left: parent.left
        anchors.top:  parent.top

        Rectangle {
            id: shapeRect
            smooth: true
            radius: 10
            height: 20
            width:  20
            color: singleBackgroundColor
            anchors.left: parent.left
            anchors.top:  parent.top
        }
    }

    states: [
        State {
            name: "topLeft"
        },
        State {
            name: "topRight"
            PropertyChanges {
                target: roundedCorner
                anchors.right: parent.right
                anchors.left: undefined
            }
            PropertyChanges {
                target: shapeRect
                anchors.leftMargin: - shapeRect.width/2
            }
        }
    ]
}
