// -*- mode: js; js-indent-level: 4; -*-

function _log (message, trace) {
    message = '[favorites] ' + message;

    // We don't log because log object's scope it seems to be broken for
    // createObject / createComponent after using the application for a while

    // if (trace) {
    //     log.trace(message);
    // } else {
    //     log.info(message);
    // }
}

function getPlace () {
    var position = storeObjectProperties.position,
        address = storeObjectProperties.address,
        contact = storeObjectProperties.contact,
        id = storeObjectProperties.placeId,
        placesCategories = [];

    _log('lat/long of place will be ['+position.latitude+'] ['+position.longitude+']');
    _log('Pt state of place will be '+ (storeObjectProperties.isPublicTransport ? 'truthy' : 'falsy'));

    place = placesCloudAdapter.createObject(String(Math.random()) + "_" + String(Math.random()));
    place.properties = {
        title: text,
        placesId: id,
        isPt: storeObjectProperties.isPublicTransport,

        contact: contact.phone,

        geoLatitude: position.latitude,
        geoLongitude: position.longitude,

        addrCityName: address.city,
        addrCountryCode: address.countryCode,
        addrCountryName: address.country,
        addrHouseNumber: address.streetNumber,
        addrPostalCode: address.postalCode,
        addrStreetName: address.street,

        phoneNumber: contact.phone,
        url: contact.web
    };

    if (id) {
        place.placeId = id;
    }

    // FYI structure of place.details.categories
/*
         "category" : [
            {
               "categorySystemName" : "find-places",
               "language" : "en",
               "name" : "hotel",
               "displayName" : "Hotel"
            },
            {
               "categorySystemName" : "find-places",
               "language" : "en",
               "name" : "accommodation",
               "displayName" : "Accommodation"
            },
            {
               "categorySystemName" : "find-places",
               "language" : "en",
               "name" : "landmark-attraction",
               "displayName" : "Landmark / Attraction"
            },
            {
               "categorySystemName" : "find-places",
               "language" : "en",
               "name" : "restaurant",
               "displayName" : "Restaurant"
            }
         ]
*/

    if (categories) {
        categories.forEach(function (value) {
            placesCategories.push({ name: value });
        });
    }

    place.details = { categories: { category: placesCategories } };
    _log('restored place categories as '+JSON.stringify(place.details.categories.category));

    place.isFavorite = true;
    place.favorite = favoriteObject;
    if (place.properties.isPt) {
        place.details = { categories: { category: {name: "public-transport"} } };
        cloudAdapter.searchForPtPlace(place);
    }
    place.restoreIconPathFromCategories();

    return place;
}
