import QtQuick 1.0
import ovi.connector 1.0
import ovi.connector.places 1.0
import "Favorite.js" as JS
import "FavoritePlacesCache.js" as Cache

ConnectedObject {
    id: favoriteObject
    property variant storeObject
    property variant storeObjectProperties
    property variant place
    property variant _placeBackupPointerKeeper
    onPlaceChanged: {
        if (place) {
            _placeBackupPointerKeeper = { removeFromStore: place.removeFromStore };
        }
    }
    cloudAdapter: mainscreen.favoritesCloudAdapter
    property variant placesCloudAdapter: mainscreen.placesCloudAdapter

    property int syncId
    property string key
    property string text
    property string description
    property variant categories

    property bool isFuzzy: false // Whether the location has *no* Place ID, only coordinates

    function getPlace() {
         var timestamp = storeObject.modificationDate; // not really unix time, it's preformatted - beware!

         if (!place) {
             place = Cache.get(key, timestamp);
         }

        if (!place) {
            place = JS.getPlace();
            Cache.save(key, timestamp, place);
        }

        return place;
    }

    function isReady() {
        return true;
    }

    Component.onDestruction: {
        if (place) place.destroy();
    }
}
