// -*- mode: js; js-indent-level: 4; -*-

// Please don't remove -- akahl20110518
.pragma library

var REQ_QUERY = 1;
var REQ_READ = 2;
var REQ_CREATE = 3;
var REQ_UPDATE = 4;
var REQ_REMOVE = 5;
var REQ_REMOVE_ALL = 6;

var ITEM_REMOVED = 1001;
var ITEM_CREATED = 1002;
var ITEM_UPDATED = 1003;

var queue = [];
var eventListener = [];
var objects = {};
var maxResults = 200;

function log (message) {
    if (false) { // as this is pragma library, cannot use logger - only activate if tracing required
        log.trace('[favorites] ' + message);
    }
}

function onItemChanged(object, flag) {
    for ( var i = 0, l = eventListener.length; i < l; i++ ) {
        try {
            if (eventListener[i] && eventListener[i].model) {
                switch (flag) {

                    case ITEM_CREATED:
                        eventListener[i].model.itemCreated(object);
                        break;

                    case ITEM_REMOVED:
                        eventListener[i].model.itemRemoved(object);
                        break;

                    case ITEM_UPDATED:
                        eventListener[i].model.itemUpdated(object);
                        break;
                }
            }
        } catch (e) {
            log("FavoritesCloudAdapter: can't update listener, error : " + e);
        }
    }
}


function addEventListener(el) {
    for ( var i = 0, l = eventListener.length; i < l; i++ ) {
        if (eventListener[i] === el) {
            return;
        }
    }
    eventListener.push(el);
}


function getKey(id) {
    if (objects.hasOwnProperty(id)) {
        return id;
    }
    return null;
}

function getFromStore(id) {
    log('Trying to get ['+id+'] from store..');

    var key = getKey(id);
    if (key) {
        log('success');
        return objects[key];
    }
    log('fail');
    return null;
}
