import QtQuick 1.0

import com.nokia.meego 1.0

import ovi.connector 1.0
import ovi.connector.places 1.0

Page {
    id: favoritesPickerPage

    property variant pickedObject
    signal favoritePicked(variant object, variant listModel)

    objectName: "favoritesPickerPage"
    tools: ToolBarLayout {
        ToolIcon {
            objectName: "toolBarIconBackButton"
            iconId: "icon-m-toolbar-back"
            onClicked: pageStack.pop()
        }
        //icon-m-toolbar-view-menu is not functional at the moment
        //        ToolIcon { iconId: "icon-m-toolbar-view-menu"; }
    }

    function _log (message, trace) {
        message = '[favorites-picker] ' + message;

        if (trace) {
            log.trace(message);
        } else {
            log.info(message);
        }
    }

    FavoritesPicker {
        id: picker

        onPicked: {
            favoritePicked(pickedObject, listModel);
        }
    }

    onStatusChanged: {
        if (status == PageStatus.Activating) {
            picker.blurMe();
            picker.emptyModel = false;
            _log('going to update list because status changed', true);
            picker.updateList();
        }
    }
}
