var ptQueue = [];

function addToPtQueue(aPlace) {
    log.trace(" [favorites::pt]: pushing place on pt queue: " + aPlace.properties.title);
    ptQueue.push(aPlace);
    startPtQueue();
}

function startPtQueue() {
    if (!transitDb.busy && ptQueue.length > 0) {
        log.trace("  [favorites::pt]:  starting search for " + ptQueue[0].properties.title);
        var item = ptQueue[0];
        tmpGeo.latitude = item.properties.geoLatitude;
        tmpGeo.longitude = item.properties.geoLongitude;
        transitDb.busy = true;
        transitDb.stopSearchDone.connect(ptSearchDone);
        transitDb.searchStop(tmpGeo, 1);
        ptSearchTimer.start();
    }
}

function ptSearchDone() {
    log.trace("  [favorites::pt]: pt search finished with " + transitDb.stops.length + " stops");
    if(!ptQueue[0]) {
        __resetDatabaseReady();
    } else if(transitDb.stops.length > 0) {
        ptSearchTimer.stop();
        __resetDatabaseReady();
        var ptInfo = mainscreen.placesCloudAdapter.getPtInfoFromStop(transitDb.stops[0]);

        var place = ptQueue[0];
        ptQueue.splice(0, 1); //remove the first on the list
        place.publictransport = ptInfo.publictransport;
        place.properties = ptInfo.properties;
        place.categories = ptInfo.categories;
        place.details = { categories: { category: {name: "public-transport"} } };
        startPtQueue();
    }
}

function __resetDatabaseReady() {
    transitDb.stopSearchDone.disconnect(ptSearchDone);
    transitDb.busy = false;
}

function placeSearchTimedOut() {
    __resetDatabaseReady();
    if(ptQueue.length > 0) {
        var first = ptQueue[0];
        ptQueue.splice(0, 1);
        ptQueue.push(first);
        startPtQueue();
    }
}
