import QtQuick 1.0
import ovi.connector.map 1.0

Image {
    width: parent.width
    height: 120

    property alias placeTitle: placeTitle.text
    property alias placeAddress: placeAddress.text
    property alias categoryIcon: categoryIcon.source
    property int distance

    source: placesAssetsPath + "images/layout/title-background.png"

    Item {
        id: iconArea
        height: parent.height
        width:111
        anchors.left:  parent.left

        Image {
            id: categoryIcon
            anchors.horizontalCenter: parent.horizontalCenter
            anchors.verticalCenter: parent.verticalCenter

        }
    }

    Column {
        width: parent.width - iconArea.width
        anchors.verticalCenter: parent.verticalCenter
        anchors.left: iconArea.right
        Text {
            width: parent.width - 100
            id: placeTitle
            color: "white"
            font.weight: Font.Bold
            font.pixelSize: 32
            elide: Text.ElideRight
        }
        Text {
            width: parent.width - 100
            id: placeAddress
            color: "white"
            font.weight: Font.Light
            font.pixelSize: 20
            elide: Text.ElideRight
        }
    }

    Text {
        color: "#aaa"
        text: units.normalizeDistance(distance).readableWithUnits
        anchors.right: parent.right
        anchors.verticalCenter: parent.verticalCenter
        font.letterSpacing: -1
        anchors.rightMargin: 10
        font.pixelSize: 20
    }

    Rectangle {
        anchors.bottom: parent.bottom

        height: 4
        width: parent.width
        gradient: Gradient {
            GradientStop { position: 0.0; color: "black" }
            GradientStop { position: 1.0; color: "transparent" }
        }
        opacity: 0.5
        z: 1
    }

    Units { id: units }

}
