import QtQuick 1.0

import com.nokia.meego 1.0

Rectangle {
    id: self
    parent: mainscreen
    visible: false
    anchors.centerIn: parent
    width: mainscreen.width
    height: mainscreen.height
    color: "#000000"

    signal accepted;
    signal canceled;    

    property string titleText
    property string message
    property alias acceptButtonText: acceptButton.text
    property alias rejectButtonText: cancelButton.text

    property int textWidth: mainscreen.width * 0.7
    property int buttonWidth: (mainscreen.width / 2) * 0.9

    function open() {
        self.visible = true;
    }

    Column {
        anchors.centerIn: parent;
        spacing: 10

        Column {
            spacing: 0
            anchors.horizontalCenter: parent.horizontalCenter

            Text {
                id: titleLabel
                anchors.horizontalCenter: parent.horizontalCenter
                horizontalAlignment: Text.Center
                text: titleText
                color: "#0099FF"
                font.pixelSize: 32
                width: textWidth
                textFormat: Text.AutoText
                wrapMode: Text.WordWrap
            }

            Text {
                id: messageLabel
                anchors.horizontalCenter: parent.horizontalCenter
                horizontalAlignment: Text.Center
                text: message
                color: "#FFFFFF"
                font.pixelSize: 25
                width: textWidth
                textFormat: Text.AutoText
                wrapMode: Text.WordWrap
            }
        }

        Row {
            anchors.horizontalCenter: parent.horizontalCenter
            spacing: 5

            Button {
                id: acceptButton
                text: ""
                onClicked: self.accepted();
                width: buttonWidth
                platformStyle: ButtonStyle {inverted: true}
            }

            Button {
                id: cancelButton
                text: ""
                onClicked: { self.visible = false; }
                width: buttonWidth
                platformStyle: ButtonStyle {inverted: true}
            }
        }
    }
}

