import QtQuick 1.0

Item {
    id: self
    clip: true
    height: 49

    signal selected;
    property bool  active: false
    property alias text: rectText.text
    property alias radius: rect.radius
    property bool  roundLeft: false
    property bool  checkable: true

    Rectangle {
        id: rect
        x: roundLeft ? 0 : -radius
        width: parent.width + radius
        height: parent.height
        color: "#FFFFFF"

        Text {
            id: rectText
            anchors.centerIn: parent
            font.pixelSize: 25
            font.bold: true
            color: "#000000"
            smooth: true
            anchors.horizontalCenterOffset: (roundLeft ? -radius : +radius) / 2
        }
    }

    states: State {
        name: "active"
        when: self.active
        PropertyChanges { target: rect;     color: "#3399FF" }
        PropertyChanges { target: rectText; color: "#FFFFFF" }
    }

    MouseArea {
        anchors.fill: parent;
        onClicked: {
            if (!self.active) {
                var parent = self.parent;
                if (parent && parent.children) {
                    var child, len = parent.children.length;
                    for (var i = 0; i < len; i++) {
                        child = parent.children[i];
                        if (child && child != self && child.checkable) {
                            child.active = false;
                        }
                    }
                }

                self.active = true;
                self.selected();
            }
        }
    }
}
