import QtQuick 1.0

Rectangle {
    id: dotBlinker

    property int numberOfBlinks: 1

    width: 30
    height: 30
    radius: 15

    border.color: "black"

    visible: mainscreen.showAllPositionMarkers

    function blink() {
        if (mainscreen.showAllPositionMarkers) {
            blinkTimer.go();
        }
    }

    Timer {
        id: blinkTimer

        interval: 100

        property int __MAX_REPEATS__: numberOfBlinks
        property int repeats: 0

        repeat: true

        function go() {
            repeats = 0;
            start();
            dotBlinker.opacity = 1.0;
        }

        onTriggered: {
            if (++repeats >= __MAX_REPEATS__) {
                dotBlinker.opacity = 1.0;

                stop();
            } else {
                dotBlinker.opacity = dotBlinker.opacity == 1? 0.5 : 1.0;
            }
        }
    }
}
