function handleShowMarker(marker) {
    mapView.setControl("conditional-clear-all");

    _closeInfoBubble(true);
    selectedMarker = marker;

    mapView.attachedToLocation = false;

    var data = mapView.model.getObjectData(marker);
    if (_moveMap(marker.location.geoCoordinates, infoBubbleBehavior._DEFAULT_ZOOM_LEVEL_FOR_STREET_VIEW_, data? data.boundingBox : null)) {
        _setActionToPerformOnAnimationDone(actionsToPerformOnAnimationDone.INITIALIZE_SELECTED_MARKER, { x: 0, y: 0 }, { latitude: 0, longitude: 0 });
    } else {
        _resetChainOfEvents();
    }
}

function handleShowContent(content) {
    localEmitForceClosePreventer = true;
    mapView.setControl("conditional-clear-all");
    mapView.setControl("emit-force-close-infobubble");

    _closeInfoBubble(true);

    mapView.attachedToLocation = false;

    _openInfoBubble(infoBubbleModes.EXTERNAL_CONTENT);
    ui.content = content;
    ui.contentFillsCompletely = true;

    _fixMapCenterToMatchTheInfoBubble();
}

function handleShowAt(geoPos, content) {
    if (
        infoBubbleMode == infoBubbleModes.EXTERNAL_CONTENT &&
        content.bodyText == infoBubbleModes.EXTERNAL_CONTENT.bodyText &&
        content.headingText == infoBubbleModes.EXTERNAL_CONTENT.headingText &&
        geoPos.latitude == mapView.center.latitude &&
        geoPos.longitude == mapView.center.longitude
    ) {
        content.visible = false;
        if (content.destroy) {
            content.destroy();
        } else {
            content = null;
        }
    } else {
        localEmitForceClosePreventer = true;
        mapView.setControl("conditional-clear-all");
        mapView.setControl("emit-force-close-infobubble");

        _closeInfoBubble(true);

        mapView.attachedToLocation = false;

        if (_moveMap(_prepareMapCenterToMatchTheInfoBubble(geoPos, content))) {
            content.visible = false;
            if (externalContentToApplyOnAnimationDone) {
                if (externalContentToApplyOnAnimationDone.destroy) {
                    externalContentToApplyOnAnimationDone.destroy();
                } else {
                    externalContentToApplyOnAnimationDone = null;
                }
            }
            externalContentToApplyOnAnimationDone = content;
            _setActionToPerformOnAnimationDone(actionsToPerformOnAnimationDone.INITIALIZE_EXTERNAL_CONTENT, { x: 0, y: 0 }, geoPos);
        } else {
            _resetChainOfEvents();
        }
    }
}

function handleShowFromMap(geoPos, extraData) {
    mapView.setControl("conditional-clear-all");

    _closeInfoBubble(true);

    mapView.attachedToLocation = false;

    if (_moveMap(geoPos, null, null, extraData.instantMove)) {
        extraData.latitude = geoPos.latitude;
        extraData.longitude = geoPos.longitude;
        extraDataToApplyOnAnimationDone = extraData;
        _setActionToPerformOnAnimationDone(actionsToPerformOnAnimationDone.INITIALIZE_SHOW_FROM_MAP, { x: 0, y: 0 }, geoPos);
    } else {
        _resetChainOfEvents();
    }
}

function handleResetall(force) {
    _closeInfoBubble(force);
}

function handleGetListView(data) {
    var tmp = spareListView.createObject(infoBubbleBehavior);
    if (data) {
        for (var i in data) {
            tmp.model.append(data[i]);
        }
    }
    return tmp;
}

function handleMapViewMouseDown() {
    mouseDown = true;
}

function handleMapViewMouseUp() {
    mouseDown = false;
}

function handleMapViewMapClicked(pixelPos, geoPos, mapObject) {
    _closeInfoBubble();

    if (mapObject) {
        if (!mapView.getBehavior(mapView._NO_INFO_BUBBLE_DEFAULT_OBJECT_PRESS_ACTION_)) {
            if (mapObject.type == MapObject.MAPICON && mapView.model.getObjectData(mapObject)) {
                _showSelectedMarker();
                selectedMarker = mapObject;

                if (_moveMap(selectedMarker.location.geoCoordinates)) {
                    _setActionToPerformOnAnimationDone(actionsToPerformOnAnimationDone.INITIALIZE_SELECTED_MARKER, pixelPos, geoPos);
                } else {
                    _resetChainOfEvents();
                }
            } else if (!mapView.getBehavior(mapView._NO_PUBLIC_TRANSPORT_STOPS_CLICK_) && (mapObject.type == MapObject.TRANSITSTOP)) {
                _showSelectedMarker();
                selectedMarker = mapObject;

                if (_moveMap(selectedMarker.geoCoordinates)) {
                    _setActionToPerformOnAnimationDone(actionsToPerformOnAnimationDone.INITIALIZE_SELECTED_PUBLIC_TRANSPORT_STOP, pixelPos, geoPos);
                } else {
                    _resetChainOfEvents();
                }
            }
        }
    }
}

function handleMapViewMapCurrentLocationClicked(pixelPos, geoPos, mapObject) {
    _closeInfoBubble();

    if (_moveMap(mapView.currentPosition? mapView.currentPosition.geoCoordinates : mapView.previousPosition.geoCoordinates)) {
        _setActionToPerformOnAnimationDone(actionsToPerformOnAnimationDone.REVERSE_GEO_CODE_CURRENT_POSITION, pixelPos, geoPos);
    } else {
        _resetChainOfEvents();
    }
}

function handleMapViewDoubleClicked() {
    _closeInfoBubble();
}

function handleMapViewCenterChanged() {
    if (mouseDown) {
        _doDefaultMapInteractionBehaviour(mapView.center, true);
    } else if (infoBubbleMode == infoBubbleModes.CURRENT_POSITION) {
        if (_shallReverseGeoCodeInCurrentPositionMode(mapView.center)) {
            reverseGeoCodeFinderMode = reverseGeoCodeFinderModes.POPULATE_AFTER_CURRENT_POSITION;
            _applyTemporaryUiContext(_requestReverseGeoCode(mapView.center).context, reverseGeoCodeFinderMode);

            mapView.model.selectObject({type: "longPress", position: mapView.center});
        } else {
            _populateInfoBubbleWithReverseGeoCodeData();
        }
    }
}

function handleMapViewZoomScaleChanged() {
    if (ui.fingerDownOnInfoBubble && infoBubbleMode != infoBubbleModes.CURRENT_POSITION) {
        _closeInfoBubble();
    } else {
        if (infoBubbleMode == infoBubbleModes.LONG_PRESS) {
            reverseGeoCodeFinderMode = reverseGeoCodeFinderModes.POPULATE_AFTER_LONG_PRESS;
            _applyTemporaryUiContext(_requestReverseGeoCode(mapView.center).context, reverseGeoCodeFinderMode);

            mapView.model.selectObject({type: "longPress", position: mapView.center});
        } else {
            _doDefaultMapInteractionBehaviour(mapView.center, true);
        }
    }
}

function handleMapViewOrientationChanged() {
    _doDefaultMapInteractionBehaviour(mapView.center, true);
}

function handleMapViewFlyToCurrentPosition() {
    _closeInfoBubble();
}

function handleMapViewMapLongPressRectangleCompleted(pixelPos, geoPos) {
    _blockInteractivityForWhile();

    _closeInfoBubble();

    if (_moveMap(geoPos)) {
        if (!mapView.getBehavior(mapView._NO_INFO_BUBBLE_DEFAULT_LONG_PRESS_ACTION_)) {
            _setActionToPerformOnAnimationDone(actionsToPerformOnAnimationDone.REVERSE_GEO_CODE_LONG_PRESS, pixelPos, geoPos)
        }
    } else {
        _resetChainOfEvents();
    }
}

function handleMapViewAnimationDone() {
    if (actionToPerformOnAnimationDone) {
        var someExceptionsToDestinationPoint =
            (actionToPerformOnAnimationDone == actionsToPerformOnAnimationDone.INITIALIZE_SHOW_FROM_MAP && extraDataToApplyOnAnimationDone) ||
            (ui.anchors.verticalCenterOffset != 0)
        ;
        var reachedDestination =
            (Math.abs(moveToDestinationGeoCoordinates.latitude - mapView.center.latitude) <= infoBubbleBehavior._MAXIMUM_DIFFERENCE_BETWEEN_DESTINATION_AND_FINAL_ANIMATION_CENTER_) &&
            (Math.abs(moveToDestinationGeoCoordinates.longitude - mapView.center.longitude) <= infoBubbleBehavior._MAXIMUM_DIFFERENCE_BETWEEN_DESTINATION_AND_FINAL_ANIMATION_CENTER_)
        ;
        if (someExceptionsToDestinationPoint || reachedDestination) {
            if (actionToPerformOnAnimationDone == actionsToPerformOnAnimationDone.REVERSE_GEO_CODE_LONG_PRESS) {
                _openInfoBubble(infoBubbleModes.LONG_PRESS);
                reverseGeoCodeFinderMode = reverseGeoCodeFinderModes.POPULATE_AFTER_LONG_PRESS;
                _applyTemporaryUiContext(_requestReverseGeoCode(mapView.center).context, reverseGeoCodeFinderMode);
            } else if (actionToPerformOnAnimationDone == actionsToPerformOnAnimationDone.REVERSE_GEO_CODE_CURRENT_POSITION) {
                _openInfoBubble(infoBubbleModes.CURRENT_POSITION);
                reverseGeoCodeFinderMode = reverseGeoCodeFinderModes.POPULATE_AFTER_CURRENT_POSITION;
                _applyTemporaryUiContext(
                    _requestReverseGeoCode(mapView.center).context,
                    reverseGeoCodeFinderMode
                );

                mapView.attachedToLocation = true;
            } else if (actionToPerformOnAnimationDone == actionsToPerformOnAnimationDone.INITIALIZE_SELECTED_MARKER && selectedMarker) {
                _openInfoBubble(infoBubbleModes.MARKER_SELECTED);
                var currentIconData = mapView.model.getObjectData(selectedMarker);
                if (currentIconData) {
                    ui.content = reverseGeoCodeFinder.createContextFromTitleAndAddress(currentIconData.title, currentIconData.address);
                }
            } else if (actionToPerformOnAnimationDone == actionsToPerformOnAnimationDone.INITIALIZE_SELECTED_PUBLIC_TRANSPORT_STOP && selectedMarker) {
                _openInfoBubble(infoBubbleModes.MARKER_SELECTED_PIBLIC_TRANSPORT);
                if (selectedMarker.transitStopInfo) {
                    var transitStopInfo = selectedMarker.transitStopInfo;

                    var transportCaption = transitStopInfo.officialName;
                    var transportDescription = qsTranslate("Maps", "qtn_mapconnector_bubblebehavior_clickdetails");

                    var lines = transitStopInfo.lines;
                    if (lines) {
                        var desc = "";
                        if (transitDb) {
                            for (var i = 0, l = lines.length; i < l; i++) {
                                var line = transitDb.getLineInfo(lines[i]);
                                if (line)
                                    desc += line.officialName + ((i < l - 1)? ", " : "");
                            }
                        }
                        transportDescription = desc;
                    }

                    ui.content = reverseGeoCodeFinder.createContextFromTitleAndAddress(transportCaption, transportDescription);
                }
            } else if (actionToPerformOnAnimationDone == actionsToPerformOnAnimationDone.INITIALIZE_EXTERNAL_CONTENT && externalContentToApplyOnAnimationDone) {
                _openInfoBubble(infoBubbleModes.EXTERNAL_CONTENT);
                ui.content = externalContentToApplyOnAnimationDone;

                ui.contentFillsCompletely = true;
                ui.forceWidth = externalContentToApplyOnAnimationDone.maxWidth || externalContentToApplyOnAnimationDone.width;

                localEmitForceClosePreventer = false;
            } else if (actionToPerformOnAnimationDone == actionsToPerformOnAnimationDone.INITIALIZE_SHOW_FROM_MAP && extraDataToApplyOnAnimationDone) {
                if (!extraDataToApplyOnAnimationDone.skipInfoBubble) {
                    _openInfoBubble(infoBubbleModes.SHOW_FROM_MAP);
                }

                if (!extraDataToApplyOnAnimationDone.title) {
                    reverseGeoCodeFinderMode = reverseGeoCodeFinderModes.POPULATE_AFTER_SHOW_FROM_MAP;
                    _applyTemporaryUiContext(_requestReverseGeoCode(mapView.center).context, reverseGeoCodeFinderMode);
                } else {
                    ui.content = reverseGeoCodeFinder.createContextFromTitleAndAddress(extraDataToApplyOnAnimationDone.title, extraDataToApplyOnAnimationDone.address);
                }

                if (extraDataToApplyOnAnimationDone.zoomScale) {
                    mapView.callMapApi("zoomTo", [extraDataToApplyOnAnimationDone.zoomScale, null, true]);
                } else if (extraDataToApplyOnAnimationDone.zoomLevel) {
                    mapView.callMapApi("zoomToLevel", [extraDataToApplyOnAnimationDone.zoomLevel, null, true]);
                }
                if (extraDataToApplyOnAnimationDone.createIcon) {
                    selectedMarker = mapView.model.appendIcon(
                        extraDataToApplyOnAnimationDone.latitude,
                        extraDataToApplyOnAnimationDone.longitude,
                        mapAssetsPath + "images/categories/mobile_map_address.png",
                        {
                            uri: extraDataToApplyOnAnimationDone.placeId? extraDataToApplyOnAnimationDone.placeId : -1,
                            title: extraDataToApplyOnAnimationDone.title,
                            address: extraDataToApplyOnAnimationDone.address
                        },
                        { }
                    );
                    if (!extraDataToApplyOnAnimationDone.skipInfoBubble) {
                        selectedMarker.visible = false;
                    }
                }
            }
        }
    }

    resetChainOfEventsAfterAnimationDone.start();
}

function handleMapViewUserInteractionChanged() {
    if (!mapView.invisibleBlockInteractivity) {
        _resetChainOfEvents();
    }
}

function handleMapViewControlChanged() {
    if (!actionToPerformOnAnimationDone) {
        if (mapView.control == "close-infobubble") {
            if (!localEmitForceClosePreventer) {
                _closeInfoBubble(true);
            }
        } else if (mapView.control == "forget-selected-marker") {
            _showSelectedMarker();
        }
    }
}

function handleUiInfoBubbleClicked() {
    if (selectedMarker) {
        var tmpObjectStashed = mapView.model.getObjectData(selectedMarker);
        if (tmpObjectStashed && tmpObjectStashed.uri && tmpObjectStashed.uri != -1) {
            mapView.placeSelected(tmpObjectStashed.uri);
        } else {
            reverseGeoCodeFinderMode = reverseGeoCodeFinderModes.POPULATE_AND_EMIT_POSITION_SELECTED;
            _requestReverseGeoCode(mapView.center);
        }
    } else {
        reverseGeoCodeFinderMode = reverseGeoCodeFinderModes.POPULATE_AND_EMIT_POSITION_SELECTED;
        _requestReverseGeoCode(mapView.center);
    }
}

function handleUiInfoBubbleDoubleClicked() {
    mapView.callMapApi("zoomToLevel", [infoBubbleBehavior._DEFAULT_ZOOM_LEVEL_FOR_STREET_VIEW_, null, false]);
}

function handleUiInfoBubbleClosed() {
    _closeInfoBubble();
}

function handleUiInfoBubbleVisibilityChanged() {
    if (!ui.open) {
        if (openSelectedMarkerOnInfoBubbleVisibled) {
            _showSelectedMarker();
        }
        if (setVerticalCenterOffsetToZeroOnAnimationDone) {
            ui.anchors.verticalCenterOffset = 0;
        }
        setVerticalCenterOffsetToZeroOnAnimationDone = true;
    }
}

function handleReverseGeoCodeFinderFindPureDataCompleted(contextData) {
    if (reverseGeoCodeFinderMode == reverseGeoCodeFinderModes.POPULATE_AND_EMIT_POSITION_SELECTED) {
        var data = contextData;
        var properties = {
            title: data["ADDR_STREET_NAME"] || data["ADDR_CITY_NAME"] || data["ADDR_COUTRY_NAME"],
            geoLatitude: mapView.center.latitude,
            geoLongitude: mapView.center.longitude,
            addrCityName: data["ADDR_CITY_NAME"],
            addrCountryCode: data["ADDR_COUNTRY_CODE"],
            addrCountryName: data["ADDR_COUNTRY_NAME"],
            addrDistrictName: data["ADDR_DISTRICT_NAME"],
            addrHouseNumber: data["ADDR_HOUSE_NUMBER"],
            addrPostalCode: data["ADDR_POSTAL_CODE"],
            addrStreetName: data["ADDR_STREET_NAME"]
        };

        if (properties.title) {
            mapView.positionSelected(properties, infoBubbleMode == infoBubbleModes.CURRENT_POSITION);
        }

        reverseGeoCodeFinderMode = null;
    }
}

function handleReverseGeoCodeFinderFindComplete(id, geoPos, context) {
    if (id == currentReverseGeoCodeRequestId && reverseGeoCodeFinderMode) {
        if (infoBubbleMode) {
            _applyTemporaryUiContext(context, reverseGeoCodeFinderMode, true);
        }

        if (reverseGeoCodeFinderMode == reverseGeoCodeFinderModes.POPULATE_AFTER_SHOW_FROM_MAP && selectedMarker) {
            if (!mapView.model.getObjectDataKey(selectedMarker, "title") || !mapView.model.getObjectDataKey(selectedMarker, "address")) {
                if (context.headingText) {
                    mapView.model.setObjectDataKey(selectedMarker, "title", context.headingText);
                } else {
                    mapView.model.setObjectDataKey(selectedMarker, "title", qsTranslate("Maps", "qtn_mapconnector_geocoder_nodata_bubble"));
                }

                if (context.bodyText) {
                    mapView.model.setObjectDataKey(selectedMarker, "address", context.bodyText);
                } else {
                    mapView.model.setObjectDataKey(selectedMarker, "address", " ");
                }
            }
        }

        reverseGeoCodeFinderMode = null;
    }
}

function handleResetChainOfEventsAfterAnimationDone() {
    _resetChainOfEvents();
}

function handleSmoothTemporaryUiContextApplierTriggered() {
    if (infoBubbleMode) {
        ui.content = smoothTemporaryUiContextApplier.temporaryContext;

        if (smoothTemporaryUiContextApplier.reverseGeoCodeFinderMode == reverseGeoCodeFinderModes.POPULATE_AFTER_CURRENT_POSITION) {
            _populateInfoBubbleWithReverseGeoCodeData();
        }
    }

}

function handlePostRotateInfoBubbleFixToScreen() {
    if (internals.fixMapCenterToMatchTheInfoBubble()) {
        postRotateInfoBubbleFixToScreen.stop();
    } else {
        //log.trace("still waiting, retry....")
    }
}

function handleUnblockInteractivityOfMapInWhile() {
    mapView.invisibleBlockInteractivity = false;
}

var mouseDown = false;

var actionsToPerformOnAnimationDone = {
    REVERSE_GEO_CODE_LONG_PRESS: 1,
    REVERSE_GEO_CODE_CURRENT_POSITION: 2,
    INITIALIZE_SELECTED_MARKER: 3,
    INITIALIZE_SELECTED_PUBLIC_TRANSPORT_STOP: 4,
    INITIALIZE_EXTERNAL_CONTENT: 5,
    INITIALIZE_SHOW_FROM_MAP: 6,
    OTHER: 99
};
var actionToPerformOnAnimationDone;
var actionToPerformOnAnimationDonePressCenter = { empty: true, x: null, y: null, latitude: null, longitude: null };
var moveToDestinationGeoCoordinates = { latitude: null, longitude: null };

var selectedMarker = null;
var openSelectedMarkerOnInfoBubbleVisibled = false;

var infoBubbleModes = {
    LONG_PRESS: 1,
    CURRENT_POSITION: 2,
    MARKER_SELECTED: 3,
    MARKER_SELECTED_PIBLIC_TRANSPORT: 4,
    EXTERNAL_CONTENT: 5,
    SHOW_FROM_MAP: 6,
    OTHER: 99
};
var infoBubbleMode = null;

var currentReverseGeoCodeRequestId = null;

var reverseGeoCodeFinderModes = {
    POPULATE_AND_EMIT_POSITION_SELECTED: 1,
    POPULATE_AFTER_LONG_PRESS: 2,
    POPULATE_AFTER_CURRENT_POSITION: 3,
    POPULATE_AFTER_SHOW_FROM_MAP: 4,
    OTHER: 99
};
var reverseGeoCodeFinderMode = null;

var latestReverseGeoCodeCoordinates = { latitude: null, longitude: null };

var reverseGeoCodeEveryNMeters = 10;

var externalContentToApplyOnAnimationDone = null;
var extraDataToApplyOnAnimationDone = null;

var setVerticalCenterOffsetToZeroOnAnimationDone = true;
var localEmitForceClosePreventer = false;

function _moveMap(geoPos, zoomLevel, boundingBox, teleportMode) {
    var result;

    if (geoPos) {
        if (!mainscreen.acceptBoundingBoxesWhileOpeningInfoBubbles || !boundingBox) {
            moveToDestinationGeoCoordinates.latitude = geoPos.latitude;
            moveToDestinationGeoCoordinates.longitude = geoPos.longitude;

            spareGeoCoordinates.latitude = geoPos.latitude;
            spareGeoCoordinates.longitude = geoPos.longitude;
            mapView.moveTo(
                spareGeoCoordinates,
                teleportMode? Map.ANIMATION_NONE : Map.ANIMATION_LINEAR,
                zoomLevel? mapView.zoomLevels[zoomLevel] : Map.PRESERVE_ZOOM_SCALE,
                Map.PRESERVE_ORIENTATION,
                Map.PRESERVE_PERSPECTIVE
            );
        } else {
            spareGeoRect.top = boundingBox.geoBbxLatitude1;
            spareGeoRect.bottom = boundingBox.geoBbxLatitude2;
            spareGeoRect.left = boundingBox.geoBbxLongitude1;
            spareGeoRect.right = boundingBox.geoBbxLongitude2;

            if (spareGeoRect.isValid) {
                mapView.moveToRect(
                    spareGeoRect,
                    Qt.rect(0, 0, mapView.width, mapView.height),
                    teleportMode? Map.ANIMATION_NONE : Map.ANIMATION_LINEAR
                );
            } else {
                _moveMap(geoPos, zoomLevel);
            }
        }

        if (teleportMode) {
            fakeAnimationDoneOnNoAnimationMoves.start();
        }

        result = true;
    } else {
        result = false;
    }

    return result;
}

function _setActionToPerformOnAnimationDone(action, pixelPos, geoPos) {
    var result;

    if (geoPos) {
        actionToPerformOnAnimationDone = action;
        actionToPerformOnAnimationDonePressCenter.empty = false;
        actionToPerformOnAnimationDonePressCenter.x = pixelPos.x;
        actionToPerformOnAnimationDonePressCenter.y = pixelPos.y;
        actionToPerformOnAnimationDonePressCenter.longitude = geoPos.longitude;
        actionToPerformOnAnimationDonePressCenter.longitude = geoPos.longitude;

        result = true;
    } else {
        result = false;
    }

    return result;
}

function _resetChainOfEvents() {
    if (actionToPerformOnAnimationDone) {
        actionToPerformOnAnimationDone = null;
        actionToPerformOnAnimationDonePressCenter = { empty: true, x: null, y: null, latitude: null, longitude: null };
        moveToDestinationGeoCoordinates = { latitude: null, longitude: null };
    }
}

function _openInfoBubble(mode) {
    ui.open = true;
    infoBubbleMode = mode;
    _hideSelectedMarker();
}

function _closeInfoBubble(force) {
    ui.open = false;

    if (force) {
        _showSelectedMarker();
    } else {
        openSelectedMarkerOnInfoBubbleVisibled = true;
    }

    if (infoBubbleMode) {
        mapView.model.selectObject(null);
        infoBubbleMode = null;
    }

}

function _hideSelectedMarker() {
    if (selectedMarker) {
        selectedMarker.visible = false;
        mapView.updateMap();
    }
}

function _showSelectedMarker() {
    if (selectedMarker) {
        selectedMarker.visible = true;
        mapView.updateMap();

        selectedMarker = null;
        mapView.model.selectObject(null);
    }

    openSelectedMarkerOnInfoBubbleVisibled = false;
}

function _doDefaultMapInteractionBehaviour(geoPos, checkOnlyWhenMouseDown) {
    if (!actionToPerformOnAnimationDone && (checkOnlyWhenMouseDown? mouseDown : true)) {
        if (infoBubbleMode) {
            if (infoBubbleMode == infoBubbleModes.LONG_PRESS) {
                reverseGeoCodeFinderMode = reverseGeoCodeFinderModes.POPULATE_AFTER_LONG_PRESS;
                _applyTemporaryUiContext(_requestReverseGeoCode(geoPos).context, reverseGeoCodeFinderMode);

                mapView.model.selectObject({type: "longPress", position: mapView.center});
            } else {
                _closeInfoBubble();
            }
        }
    }
}

function _requestReverseGeoCode(geoPos) {
    latestReverseGeoCodeCoordinates.latitude = geoPos.latitude;
    latestReverseGeoCodeCoordinates.longitude = geoPos.longitude;
    var findObjectResult = reverseGeoCodeFinder.find(geoPos, true, true);
    currentReverseGeoCodeRequestId = (findObjectResult.id > 0)? findObjectResult.id : currentReverseGeoCodeRequestId;
    return findObjectResult;
}

function _populateInfoBubbleWithReverseGeoCodeData() {
    if (ui.content && ui.content.bodyText) {
        if (mapView.currentPosition) {
            ui.content.bodyText =
                qsTranslate("Maps", "qtn_mapconnector_bubblebehavior_current_position") +
                (
                    (mapView.currentPosition.accuracy < 100 && mapView.currentPosition.accuracy > 0)?
                        (
                            " " +
                            qsTranslate("Maps", "qtn_mapconnector_bubblebehavior_current_within") +
                            " " +
                            units.normalizeDistanceToInt(mapView.currentPosition.accuracy).readableWithUnits
                        )
                        :
                        ""
                )
            ;
        } else {
            ui.content.bodyText = qsTranslate("Maps", "qtn_mapconnector_bubblebehavior_last_known_position");
        }

        if (!ui.content.bodyText) {
            _closeInfoBubble();
        }
    }
}

function _applyTemporaryUiContext(context, reverseGeoCodeFinderMode, force) {
    smoothTemporaryUiContextApplier.temporaryContext = context;
    smoothTemporaryUiContextApplier.reverseGeoCodeFinderMode = reverseGeoCodeFinderMode;
    if (!force && ui.content && (ui.content.bodyText || ui.content.headingText)) {
        smoothTemporaryUiContextApplier.start();
    } else {
        _cancelTemporaryUiContext();
        handleSmoothTemporaryUiContextApplierTriggered();
    }
}

function _cancelTemporaryUiContext() {
    smoothTemporaryUiContextApplier.stop();
}

function _shallReverseGeoCodeInCurrentPositionMode(geoPos) {
    var result;

    if (latestReverseGeoCodeCoordinates.latitude && latestReverseGeoCodeCoordinates.longitude) {
        spareGeoCoordinates.latitude = latestReverseGeoCodeCoordinates.latitude;
        spareGeoCoordinates.longitude = latestReverseGeoCodeCoordinates.longitude;

        result = geoPos.distance(spareGeoCoordinates) > reverseGeoCodeEveryNMeters;
    } else {
        result = true;
    }

    return result;
}

function _prepareMapCenterToMatchTheInfoBubble(geoPos, content) {
    ui.anchors.verticalCenterOffset = 0;

    spareGeoCoordinates.latitude = geoPos.latitude;
    spareGeoCoordinates.longitude = geoPos.longitude;

    var point = mapView.geoToScreen(mapView.center, true);
    var delta = point.y - content.height - 50;

    if (delta < 0) {
        if (mapView.callMapLayersApi("is2dMode")) {
            point = mapView.geoToScreen(spareGeoCoordinates, true);
            point.y -= Math.abs(delta);
            var tmpGeo = mapView.screenToGeo(point, true);
            if (tmpGeo && tmpGeo.latitude && tmpGeo.longitude) {
                geoPos.latitude = tmpGeo.latitude;
                geoPos.longitude = tmpGeo.longitude;
            }
        } else {
            point.x = mapView.width / 2;
            point.y = mapView.height / 2 - delta;
            mapView.transformCenter = point;
        }

        ui.anchors.verticalCenterOffset = Math.abs(delta);

        setVerticalCenterOffsetToZeroOnAnimationDone = false;
    }

    return geoPos;
}

function _fixMapCenterToMatchTheInfoBubble() {
    if (ui.open) {
        var tmpHeight;
        if (ui.content) {
            tmpHeight = ui.content.height;
        } else if (ui._content) {
            tmpHeight = ui._content.height;
        }

        if (tmpHeight !== undefined) {
            ui.anchors.verticalCenterOffset = 0;

            var delta = mapView.height / 2 - tmpHeight - 80;

            if (delta < 0) {
                var point = mapView.geoToScreen(mapView.center, false);
                point.y += ui.anchors.verticalCenterOffset - Math.abs(delta);
                var tmpGeo = mapView.screenToGeo(point, true);
                mapView.center.latitude = tmpGeo.latitude;
                mapView.center.longitude = tmpGeo.longitude;

                ui.anchors.verticalCenterOffset = Math.abs(delta);
            }

            return true;
        } else {
            return false;
        }
    } else {
        return true;
    }
}

function _blockInteractivityForWhile() {
    unblockInteractivityOfMapInWhile.start();
    mapView.invisibleBlockInteractivity = true;
}
