import QtQuick 1.0

import com.nokia.meego 1.0

Item {
    property Component __noDataContext: noDataContext
    Component {
        id: noDataContext

        Rectangle {
            visible: false

            width: 322
            height: 60

            color: "transparent"
            //color: "red"

            Column {
                id: noDataTextContainer
                anchors.fill: parent
                anchors.topMargin: 18

                Text {
                    anchors.horizontalCenter: noDataTextContainer.horizontalCenter
                    objectName: "finderNoDataContainer"

                    font.pixelSize: 14
                    font.bold: true
                    font.family: mainscreen.__labelStyle.fontFamily

                    text: qsTranslate("Maps", "qtn_mapconnector_geocoder_nodata_bubble"); //"No data available"

                    color: "white"
                }
            }
        }
    }

    property Component __loadingContext: loadingContext
    Component {
        id: loadingContext

        Rectangle {
            visible: false

            width: 322
            height: 60

            //anchors.horizontalCenter: parent.horizontalCenter

            color: "transparent"
            //color: "yellow"

            Column {
                id: loadingTextContainer
                anchors.fill: parent
                anchors.topMargin: 18

                /*
                BusyIndicator {
                    anchors.horizontalCenter: loadingTextContainer.horizontalCenter
                    objectName: "finderLoadingTextContainer"

                    running: true;
                }
                */

                Text {
                    anchors.horizontalCenter: loadingTextContainer.horizontalCenter
                    objectName: "finderLoadingTextContainer"

                    font.pixelSize: 14
                    font.bold: true
                    font.family: mainscreen.__labelStyle.fontFamily

                    text: qsTranslate("Maps", "qtn_mapconnector_geocoder_loading_bubble"); //"Loading, please wait..."

                    color: "white"
                }
            }
        }
    }

    property Component __timeoutContext: timeoutContext
    Component {
        id: timeoutContext

        Rectangle {
            visible: false

            width: 322
            height: 60

            color: "transparent"
            //color: "white"

            Column {
                id: timeoutTextContainer
                anchors.fill: parent
                anchors.topMargin: 18

                Text {
                    anchors.horizontalCenter: timeoutTextContainer.horizontalCenter
                    objectName: "finderTimoutTextContainer"

                    font.pixelSize: 14
                    font.bold: true
                    font.family: mainscreen.__labelStyle.fontFamily

                    text: qsTranslate("Maps", "qtn_mapconnector_geocoder_nodata_bubble"); //"No data connection..."

                    color: "white"
                }
            }
        }
    }

    property Component __defaultContext: defaultContext
    Component {
        id: defaultContext

        Rectangle {
            id: prototypeDefaultContext

            visible: false

            width: 322
            height: 60

            color: "transparent"
            //color: "green"


            property alias generalText: general.text
            property alias generalDetails: generalDetails.text
            property alias headingText: heading.text
            property alias bodyText: body.text
            property alias bogusText: bogus.text

            Column {
                id: generalTextContainer
                anchors.fill: parent

                visible: general.text

                Text {
                    id: general
                    objectName: "generalTxt"

                    elide: Text.ElideRight
                    anchors.left: parent.left
                    anchors.right: parent.right
                    anchors.rightMargin: 10

                    font.pixelSize: 23
                    font.bold: true
                    font.family: mainscreen.__labelStyle.fontFamily


                    color: "white"
                }

                Text {
                    id: generalDetails
                    objectName: "generalDetailsTxt"

                    elide: Text.ElideRight
                    anchors.left: parent.left
                    anchors.right: parent.right

                    textFormat: Text.RichText

                    font.pixelSize: 16
                    font.family: mainscreen.__labelStyle.fontFamily

                    color: "white"
                }
            }

            Column {
                id: regularTextContainer
                anchors.fill: parent
                anchors.topMargin: 3

                visible: heading.text || body.text

                spacing: 2

                Text {
                    id: heading
                    objectName: "headingTxt"
                    anchors.left: parent.left
                    anchors.right:  parent.right
                    anchors.rightMargin: 10

                    elide: Text.ElideRight

                    font.pixelSize: 23
                    font.bold: true

                    font.family: mainscreen.__labelStyle.fontFamily
                    color: "white"
                }

                Text {
                    id: body
                    objectName: "bodyTxt"
                    color: "white"

                    font.pixelSize: 19
                    font.family: mainscreen.__labelStyle.fontFamily

                    elide: Text.ElideRight

                    anchors.left: parent.left
                    anchors.right: parent.right
                }
            }

            Text {
                id: bogus
                color: "red"
                opacity: 0.8
                visible: false

                font.pixelSize: 11

                anchors.right: parent.right
                anchors.bottom: parent.bottom
            }
        }
    }
}
