import QtQuick 1.0
import MapsPlugin 1.0

Item {
    id: mapGlobalData

    property GeoCoordinates currentPositionGeoCoordinates: GeoCoordinates {}
    property bool currentPositionEmptry: true
    property int currentPositionAccuracy: -1
    property variant currentPositionTimestamp: null
    property variant currentPosition: !currentPositionEmptry? {fake: true, accuracy: currentPositionAccuracy, timestamp: currentPositionTimestamp, geoCoordinates: currentPositionGeoCoordinates} : null
    function updateCurrentPosition(position) {
        if (position && position.geoCoordinates && position.geoCoordinates.latitude && position.geoCoordinates.longitude) {
            if (position.accuracy) {
                currentPositionAccuracy = position.accuracy;
                currentPositionTimestamp = position.timestamp;
            } else {
                currentPositionAccuracy = -1;
            }

            currentPositionGeoCoordinates.latitude = position.geoCoordinates.latitude;
            currentPositionGeoCoordinates.longitude = position.geoCoordinates.longitude;
            currentPositionEmptry = false;
        } else {
            currentPositionEmptry = true;
        }

        currentPositionChanged(position);
    }
    signal currentPositionChanged(variant position)

    property GeoCoordinates previousPositionGeoCoordinates: GeoCoordinates {}
    property bool previousPositionEmptry: true
    property int previousPositionAccuracy: -1
    property variant previousPositionTimestamp: null
    property variant previousPosition: !previousPositionEmptry? {fake: true, accuracy: previousPositionAccuracy, timestamp: previousPositionTimestamp, geoCoordinates: previousPositionGeoCoordinates} : null
    function updatePreviousPosition(position) {
        if (position && position.geoCoordinates && position.geoCoordinates.latitude && position.geoCoordinates.longitude) {
            if (position.accuracy) {
                previousPositionAccuracy = position.accuracy;
                previousPositionTimestamp = position.timestamp;
            } else {
                previousPositionAccuracy = -1;
            }

            previousPositionGeoCoordinates.latitude = position.geoCoordinates.latitude;
            previousPositionGeoCoordinates.longitude = position.geoCoordinates.longitude;
            previousPositionEmptry = false;
        } else {
            previousPositionEmptry = true;
        }

        previousPositionChanged(position);
    }
    signal previousPositionChanged(variant position)

    property string currentPositionType: ""
    function updateCurrentPositionType(positionType) {
        currentPositionType = positionType;
        currentPositionTypeChanged(positionType);
    }
    signal currentPositionTypeChanged(string positionType)

    property variant activeMap
}
