import QtQuick 1.0
import MapsPlugin 1.0

Item {
    id: mapSharedData

    property string state: "default"
    property string mode: "default"

    property variant currentPosition: null
    function updateCurrentPosition(position) {
        currentPosition = position;
        currentPositionChanged(position);
    }
    signal currentPositionChanged(variant position)

    property variant previousPosition: null
    function updatePreviousPosition(position) {
        previousPosition = position;
        previousPositionChanged(position);
    }
    signal previousPositionChanged(variant position)

    property string currentPositionType: ""
    function updateCurrentPositionType(positionType) {
        currentPositionType = positionType;
        currentPositionTypeChanged(positionType);
    }
    signal currentPositionTypeChanged(string positionType)

    property variant currentCenter: null
    function updateCurrentCenter(center) {
        var tmp = mapSharedData.currentCenter;
        if (tmp) {
            //tmp.destroy();
            tmp = null;
        }

        if (center.clone) {
            tmp = center.clone(mapSharedData);
        } else {
            tmp = center;
        }

        mapSharedData.currentCenter = tmp;
        currentCenterChanged(center);
    }
    signal currentCenterChanged(variant center)

    property variant edgeTopLeft: null
    property variant edgeTopRight: null
    property variant edgeBottomRight: null
    property variant edgeBottomLeft: null

    property variant currentZoomScale: null
    property variant currentAttachedToLocation: false
    property variant currentDrawnHaloSize: null

    property string timeMode: "day"
    property string mapMode: "pedestrian"
    property bool mode3d: false
    property int perspective: 0
    property int orientation: 0
    property bool landmarksVisible: true
    property bool trafficInfoVisible: false
    property bool publicTransportMode: false
    property bool publicTransportModePartial: false
    property bool publicTransportLineHightlighted: false
    property variant skipPropertiesOnSaveTime: null
    signal uiChanged()

    property variant currentMapObjectSelected: null
    property variant currentTransitStopInfo: null
    property variant currentTransitStopInfoLines: null

    property string control
    function setControl(newControl) {
        control = "__fake__";
        control = newControl;
    }

    property variant propaganda
    function propagandize(newAction, newPropaganda) {
        propaganda = {action: "__fake__"};

        var tmpNewPropaganda = typeof(newPropaganda) == "object"? newPropaganda : {};
        tmpNewPropaganda.action = newAction;
        propaganda = tmpNewPropaganda;
    }

    property variant activeMap
}
