import QtQuick 1.0

import com.nokia.meego 1.0

Item {
    id: self
    height: 40
    width: parent.width

    signal stateChanged(bool enabled)
    property alias checked: button.checked
    property alias active: button.enabled
    property alias text: label.text

    Text {
        y: 7
        id: label
        anchors {
            left: parent.left
            right: parent.right
            rightMargin: button.width
        }

        text: label.text
        color: self.active? "#ffffff" : "#444444"
        font.pixelSize: 25
        font.bold: true
        elide: Text.ElideRight
    }


    CheckBox {
        id: button
        anchors.right: parent.right
        anchors.top: parent.top
        onClicked: {
            self.stateChanged(button.checked);
        }
        platformStyle: CheckBoxStyle {inverted: true}
    }

    MouseArea {
        anchors.fill: parent
        anchors.rightMargin: button.width

        onClicked: {
            if (button.enabled) {
                self.checked = !self.checked;
                self.stateChanged(button.checked);
            }
        }
    }

//    [Older stiwcher]

//    SettingButton {
//        id: button;
//        anchors.right: parent.right
//        anchors.top: parent.top
//        onStateChanged: self.stateChanged(enabled)
//    }
}

