import QtQuick 1.0
import MapsPlugin 1.0

import "MapApi.js" as MapApi

Item {
    id: zoomBar

    property variant mapView

    property real zoomStep: 0.15

    width: minusSide.width + plusSide.width + 16 * 2
    height: Math.max(minusSide.height, plusSide.height) + 16

    Behavior on opacity { PropertyAnimation { duration: 250 } }

    MouseArea {
        anchors.fill: parent
        onClicked: { }
    }

    Row {
        anchors.bottom: parent.bottom
        anchors.bottomMargin: 16
        anchors.horizontalCenter: parent.horizontalCenter
        ZoomButton {
            id: minusSide
            plus: false
            onClicked: { MapApi.zoomTo(mapView.zoomScale * (1 + zoomBar.zoomStep * 2), null, true) }
            onHold: { MapApi.zoomTo(mapView.zoomScale * (1 + zoomBar.zoomStep), null, true) }
            objectName: "zoomOut"
        }
        ZoomButton {
            id: plusSide
            plus: true;
            onClicked: { MapApi.zoomTo(mapView.zoomScale * (1 - zoomBar.zoomStep * 2), null, true) }
            onHold: { MapApi.zoomTo(mapView.zoomScale * (1 - zoomBar.zoomStep), null, true) }
            objectName: "zoomIn" // test for QA
        }
    }
}
