import QtQuick 1.0

Item {
    id: item
    property bool plus: false
    property bool enabled: true

    signal clicked
    signal hold
    signal released

    clip: true
    height: button.height
    width: button.width

    Timer {
        id: delayStarted
        interval: 100
        running: false
        repeat: false
        onTriggered: { loop.start() }
    }

    Timer {
        id: loop
        interval: 100
        running: false; repeat: true
        onTriggered: { item.hold(item.plus) }
    }

    Image {
        id: button

        source: mapAssetsPath + "images/layout/zoom-" +
                ( plus ? "plus" : "minus") +
                ( mouseArea.pressed ? "-pressed" : "") +
                ".png"
        MouseArea {
            id: mouseArea
            anchors.fill: parent
            onPressed: { item.clicked(); }
            onReleased: { loop.stop(); item.released(); }
        }

        states: State {
            name: "pressed"
            when: mouseArea.pressed

            PropertyChanges {
                target: delayStarted
                running: true
            }
        }
    }
}
