import QtQuick 1.0

import "pages" as Pages

Pages.RoutePlanner {
    id: routePlannerFlow

    property Route result
    property bool previewJumpToMode: false

    function skipToPreview(route) {
        pageStack.push(routePreview, {model: route}, true);
    }

    Component {
        id: newRoute
        Route {
            autoMode: true
        }
    }

    Component {
        id: routePreview

        Pages.RoutePreview {
            mainScreen: routePlannerFlow.mainScreen

            onForward: {
                result = route;
                routePlannerFlow.finished(error, result);
            }
        }
    }

    onForward: {
        routePlannerFlow.previewJumpToMode = true;
        skipToPreview(result);
    }

    Component.onCompleted: {
        if (!model) {
            model = newRoute.createObject(routePlannerFlow);
        }
    }
}
