import QtQuick 1.0

import com.nokia.meego 1.0

import ovi.connector 1.0

MenuItem {
    id: root

    property alias option: textItem.text      // This is the label of the menu item
    property alias checked: cbItem.checked  // Property to turn on/off the checkbox

    MapsText {
        id: textItem
        platformStyle: LabelStyle {
            fontPixelSize: root.platformStyle.fontPixelSize
            textColor: root.platformStyle.textColor
        }
        anchors {
            verticalCenter: parent.verticalCenter
            left: parent.left
            leftMargin: parent.platformStyle.leftMargin
            right: parent.right
            rightMargin: parent.platformStyle.rightMargin + cbItem.width
        }
        font.weight: root.platformStyle.fontWeight
    }

    CheckBox {
        id: cbItem
        anchors {
            right: parent.right
            verticalCenter: parent.verticalCenter
            rightMargin: parent.platformStyle.rightMargin
        }
    }

    states: [
        State {
            name: "disabled"
            when: !root.enabled
            PropertyChanges {
                target: textItem.platformStyle
                textColor: textItem.secondaryColor
            }
        }

    ]
}
