import QtQuick 1.0

import com.nokia.meego 1.0

import ovi.connector 1.0

import ".."

// Guidance View Menu - the view menu shown during guidance
Menu {
    id: guidanceMenu

    signal audioSettingsClicked
    signal backlightSettingChanged(bool checked)

    parent: mainscreen

    property alias audioChecked: audioCommandsMenuItem.checked
    property alias audioEnabled: audioCommandsMenuItem.enabled

    property alias backlightChecked: backlightMenuItem.checked
    property alias backlightEnabled: backlightMenuItem.enabled

    MenuLayout {
        CheckboxMenuItem {
            id: audioCommandsMenuItem
            objectName: "audioCommandsMenuItem"
            option: qsTranslate("Maps", "qtn_navigationconnector_guidanceviewmenu_audiocommands")
        }

        MenuItem {
            objectName: "audioSettingsMenuItem"
            text: qsTranslate("Maps", "qtn_navigationconnector_guidanceviewmenu_audiosettings")
            onClicked: audioSettingsClicked();
        }

        CheckboxMenuItem {
            id: useCompassInGuidanceMenuItem
            visible: mainscreen.magicCompass
            objectName: "useCompassInGuidanceMenuItem"
            option: qsTranslate("Maps", "qtn_navigationconnector_guidanceviewmenu_use_compass_in_guidance")
            checked: mainscreen.useMagicCompassInGuidanceInstanadOfMOS
            onCheckedChanged: { mainscreen.useMagicCompassInGuidanceInstanadOfMOS = useCompassInGuidanceMenuItem.checked }
        }

        CheckboxMenuItem {
            id: backlightMenuItem
            objectName: "backlightMenuItem"
            option: qsTranslate("Maps", "qtn_navigationconnector_guidanceviewmenu_backlight")
            onCheckedChanged: backlightSettingChanged(checked);
        }
    }
}
