import QtQuick 1.0

ManeuverDelegate {
    id: ptStop
    property bool isFirst: false
    property bool isLast: false
    property string lineName
    property color lineColor
    property bool show
    property int origHeight

    Component.onCompleted: {
        origHeight = height;
    }

    actionText: isFirst ? qsTranslate("Maps", "qtn_navigationconnector_ptmaneuverstopdelegate_geton") :
                isLast ? qsTranslate("Maps", "qtn_navigationconnector_ptmaneuverstopdelegate_getoff") : ""
    maneuverIcon: isFirst || isLast ? (navigationAssetsPath + "images/public_transport_" + (isFirst ? "ON": "OFF") + ".png") : ""

    Rectangle {
        id: line
        color: parent.lineColor

        anchors {
            top: parent.top
            topMargin: isFirst ? 60 : 0
            bottom: parent.bottom
            bottomMargin: isLast ? 60 : 0
            left: parent.left
            leftMargin: 45 + extraIconIndent
        }

        width: 5
        z: 2
    }

    Rectangle {
        id: stopMarker
        color: parent.lineColor
        visible: !isFirst && !isLast
        height: 5
        width: 10
        anchors {
            left: line.right
            verticalCenter: parent.verticalCenter
        }
        z: 2
    }


//    ParallelAnimation {
//        id: animationShow
//        NumberAnimation { target: ptStop; property: "height"; from: 0; to: origHeight; duration: 200; easing.type: Easing.OutQuad}
//        NumberAnimation { target: ptStop; property: "opacity"; from: 0; to: 1; duration: 200 }
//    }

//    ParallelAnimation {
//        id: animationHide
//        NumberAnimation { target: ptStop; property: "height"; from: origHeight; to: 0; duration: 200; easing.type: Easing.OutQuad}
//        NumberAnimation { target: ptStop; property: "opacity"; from: 1; to: 0; duration: 100 }
//    }

    onShowChanged: {
        if(show) {
            animationShow.start();
        } else {
            animationHide.start();
        }
    }
}
