import QtQuick 1.0
import ovi.connector.places 1.0
import ovi.connector.map 1.0
import MapsPlugin 1.0

import "../RoutingUtils.js" as RoutingUtils
import "RouteManeuversList.js" as Logic
import "../ManeuverConstants.js" as ManeuverConstants

PlacesCommonList {
    id: maneuverList

    property bool pt: false

    Component {
        id: walkDriveDelegate
        WalkDriveManeuverDelegate {
            objectName:  "RouteManeuverDelegate_" + index
            maneuver: maneuverList.model.get(index)
            width: maneuverList.width
        }
    }

    Component {
        id: ptDelegate
        PtManeuverDelegate {
            objectName:  "RouteManeuverDelegate_" + index
            maneuver: maneuverList.model.get(index)
            width: maneuverList.width
        }
    }


    itemDelegate: pt ? ptDelegate : walkDriveDelegate

    Units { id: units }

    function fillList (route) {
        pt = route.mode === "pt";

        Logic.fillList(maneuverList.model, ManeuverConstants.MANEUVER_ICON_INDEXES,
           function (maneuver) {
               return ManeuverConstants.getDescription(maneuver, false);
           }, function (distance) {
               return qsTranslate("Maps", 'qtn_navigationconnector_maneuverdistance_prefix')+' '+
                   units.normalizeDistance(distance).readableWithUnits;
           }, route
        );
    }

    Component.onCompleted: {
        ManeuverConstants.createManeuverIconIndexMap();
    }
}
