import QtQuick 1.0

import ovi.connector 1.0

// PlacesRecommendationsList
ConnectedList {
    id: model

    cloudAdapter: PlacesCloudAdapter {}

    signal modelUpdated(variant err);
    signal modelItemAdded();
    signal queryFailed(variant error);

    // onQueryFinished will take care of adding
    //queryMode: ConnectedList.None

    // see connectedlist.h, gets "error", "results", "model"
    onQueryFinished: {
        if (error) {
            queryFailed(error);
        } else {
            model.clear();

            for (var i = 0, l = results.length; i < l; i++) {
                try {
                    model.append(results[i]);
                    modelItemAdded();
                } catch(e) {
                    log.info(e)
                }
            }

            log.info("Data model for recommendations created.");
        }

        modelUpdated(error);
    }
}
