import QtQuick 1.0

Rectangle {
    id: self
    property int padding: 15
    color: "#f0f0f0"

    height: buttons.height > 0 ? (buttons.height + 2 * padding) : 0
    width: parent.width

    default property alias myChildren: buttons.children

    BorderImage {
        source: placesAssetsPath + "images/layout/button-group-background.png"
        border.top: 14
        border.left: 14
        border.bottom: 14
        border.right: 14

        anchors.fill: buttons
    }

    Column {
        id:buttons
        spacing: 1

        x: parent.padding
        y: parent.padding
        width: parent.width - 2* parent.padding
    }

    states: [
        State {
            when: !self.visible
            PropertyChanges {
                target: self
                height: 0
            }
        }
    ]

    Behavior on height {
        NumberAnimation { duration: 300 }
    }
}

