import QtQuick 1.0

Rectangle {
    id: infoPopup

    width: parent.width + 1
    x: -1
    height: 70
    color : "#f0f0f0"
    border.color: "#e8e8e8"
    visible: false

    property string message

    signal clicked()

    Text {
        id: textArea

        text: infoPopup.message
        onPaintedSizeChanged: {
            if (textArea.paintedWidth > infoPopup.width && infoPopup.width > 1) {
                text = infoPopup.message.substring(0, 25);
            }
        }

        anchors.horizontalCenter: parent.horizontalCenter
        anchors.verticalCenter: parent.verticalCenter

        font.pixelSize: 24
        textFormat: Text.RichText

        visible: false

        MouseArea {
            anchors.fill: parent

            onClicked: {
                infoPopup.clicked();
                message = "";
            }
        }
    }

    Timer {
        interval: 5000

        running: infoPopup.state == "shown"

        onTriggered: {
            message = "";
        }
    }

    states: [
       State {
            name: "hidden"
            when: !message
        },

        State {
            name: "shown"
            when: message
        }
    ]

    transitions: [
        Transition {
            to: "shown"

            SequentialAnimation {
                NumberAnimation { target: infoPopup; property: "height"; to: 70; duration: 60; }
                PropertyAnimation { target: textArea; property: "visible"; to: true; duration: 1; }
            }

        },

        Transition {
            to: "hidden"

            SequentialAnimation {
                PropertyAnimation { target: textArea; property: "visible"; to: false; duration: 1; }
                NumberAnimation { target: infoPopup; property: "height"; to: 0; duration: 60; }
            }

        }
    ]
}
