import QtQuick 1.0

import com.nokia.meego 1.0

Rectangle {
    id: listScene

    property Component itemDelegate
    property variant model: listModel
    property alias view: view
    property int offset: 10
    property int count: view.count
    property alias enableScrollDecorator: scrollDecorator.visible
    clip: true
    color: "#f0f1f2"

    ListModel {
        id: listModel
    }

    // The delegate for each section header
    Component {
        id: sectionHeading

        PlaceCommonListHeader {
            width: listScene.width;
            topMost: section === view.model.get(0)[view.section.property]
            title: section
        }


    }

    ListView {
        id: view
        anchors.fill: parent
        model: parent.model

        delegate: itemDelegate
        cacheBuffer: 100 * 25

        focus: true
        section.property: "categoryName"
        section.criteria: ViewSection.FullString
        section.delegate: sectionHeading
    }

    ScrollDecorator {
        id: scrollDecorator
        flickableItem: view
    }
}
