import QtQuick 1.0

// Surprise, surprise: This is actually a circle
Rectangle {
    id: self
    property string position: "left"
    property int baseRadius: 3

    color: "#000"
    width: baseRadius * 2 + 1
    height: baseRadius * 2 + 1
    radius: baseRadius

    states: [
        State {
            name: "left"
            when: position === "left"
            AnchorChanges {
                target: self
                anchors { top: parent.top; left: parent.left }
            }
            PropertyChanges {
                target: self
                anchors { leftMargin: -baseRadius }
            }
        },
        State {
            name: "right"
            when: position === "right"
            AnchorChanges {
                target: self
                anchors { top: parent.top; right: parent.right }
            }
            PropertyChanges {
                target: self
                anchors { rightMargin: -baseRadius }
            }
        }
    ]
}
