import QtQuick 1.0

import com.nokia.meego 1.0

import "../PlaceViewerLogic.js" as Logic

Button {
    id: contactBtn
    objectName: "placesContactBtn"

    property variant placeObject

    visible: Logic.getPlacePhone(placeObject) || Logic.getPlaceEmail(placeObject) || Logic.getPlaceWebsite(placeObject);
    height: 80
    anchors.left: parent.left
    anchors.leftMargin: 16
    anchors.right: parent.right
    anchors.rightMargin: 16

    platformStyle: ButtonStyle {
        horizontalAlignment: Text.AlignLeft
    }

    Image {
        id: placesContactBtnRightElem
        source: parent.enabled ? (placesAssetsPath + "images/layout/" + (parent.pressed ?"contact_pressed.png":"contact.png")) : "";
        anchors {
            verticalCenter: parent.verticalCenter
            right: parent.right
            rightMargin: 18
        }
    }

    Image {
        source: placesAssetsPath + "images/layout/"+"divider.png"
        width: 1
        anchors {
            right: placesContactBtnRightElem.left
            rightMargin: 14
            top: parent.top
            bottom: parent.bottom
            topMargin: 5
            bottomMargin: 5
        }
    }
    text: " " + qsTranslate("Maps", "qtn_placesconnector_viewer_contact_buttontitle")
    onClicked: {
        //contextMenu.open();
    }
}
