import QtQuick 1.0

import com.nokia.meego 1.0

import ovi.connector 1.0

Rectangle {
    function updateRatings() {
        var val=value;

        for (var i = 0; i < 5; i++){
            listView.model.setProperty(i, "on", Math.round(value) > i);
        }
    }

    property real value:0
    property int count:0

    id: container
    color:"transparent"
    width: visible? (starsWrapper.width + counter.paintedWidth) : 0
    height: 20

    onValueChanged: updateRatings()
    onCountChanged: updateRatings()
    Component.onCompleted: updateRatings()

    Row {
        Item {
            id: starsWrapper
            height: 20
            width: 125


            Repeater {
                id: listView
                objectName: "ratingListView"

                anchors.fill: parent

                model: ListModel {
                    ListElement {on:false}
                    ListElement {on:false}
                    ListElement {on:false}
                    ListElement {on:false}
                    ListElement {on:false}
                }

                delegate: Rectangle {
                    x: index * 25
                    clip: true
                    width: 20
                    height: parent.height
                    color: "transparent"
                    Image{
                        id: img
                        anchors.top: parent.top
                        anchors.topMargin: (parent.height - img.height) / 2
                        source: placesAssetsPath + "images/rating.png"
                        states: [
                            State {
                                name: "turnedOn"
                                when: on
                                PropertyChanges {
                                    target: img
                                }
                            },
                            State {
                                when: !on
                                name: "turnedOff"
                                PropertyChanges {
                                    target: img
                                    x: -19
                                }

                            }
                        ]
                    }
                }
            }
        }
        MapsText{
            id: counter
            anchors {
                verticalCenter: starsWrapper.verticalCenter
                verticalCenterOffset: 2
            }
            text: "(" + count + ")"
            visible: count > 0
            platformStyle: LabelStyle {fontPixelSize: 18; textColor: counter.secondaryColor; }
        }
    }
}
