import QtQuick 1.0

import com.nokia.meego 1.0

import ovi.connector 1.0

Item {
    property variant item
    height: iconId.height > textId.height ? iconId.height: textId.height
    signal itemClicked()

    Rectangle {
        id: iconBg
        width: 75
        Image {
            x: 10
            id: iconId
            sourceSize.width: 75
            sourceSize.height: 75
            source: item ? item.iconPath : ""
        }
    }

    Column {
        id: textId
        anchors.left: iconBg.right
        anchors.top: iconBg.top
        anchors.right: parent.right

        MapsText {
            id: captionId
            text: item ? item.name : ""
            width: parent.width - 10
            platformStyle: LabelStyle {fontPixelSize: 20}
            font.weight: Font.Bold
        }

        Rating {
            value: item ? item.recommendations.rating || 0 : 0
            count: item ? item.recommendations.ratingCount || 0 : 0
        }
    }

    MouseArea {
        anchors.fill: parent;
        onClicked: itemClicked();
    }

//    MouseArea {
//        anchors.fill: parent
//        onClicked: {
//            itemClicked(index);
//        }
//    }
}
