import QtQuick 1.0
import ovi.connector 1.0

Rectangle {
    height: 30 + Math.max(iconBg.height, textId.height)
    color: "#f0f1f2"
    Item {
        id: container

        width: parent.width
        anchors {
            top: parent.top
            topMargin: 15
            left: parent.left
            leftMargin: 15
        }

        Item {
            id: iconBg
            width: 75
            height: 75
            Image {
                id: iconId

                sourceSize.width: 75
                sourceSize.height: 75
                //anchors.centerIn: parent
                //anchors.horizontalCenterOffset: - paintedWidth
                //anchors.verticalCenterOffset: - paintedHeight
                smooth: true

                source: icon
            }
        }

        Column {
            id: textId
            width: parent.width
            anchors {
                top: iconBg.top
                left: iconBg.right
            }

            MapsText {
                id: captionId
                objectName: "captionId"
                text: caption
                state: "listSmallBold"
                width: parent.width-iconBg.width - 30
            }

            MapsText {
                width: parent.width-iconBg.width - 30
                text: description.substr(0,100) + (description.length > 100? "..." : "")
                state: "listLightWrap"
                textFormat:Text.RichText
            }
        }
    }
}
