import QtQuick 1.0

import com.nokia.meego 1.0

import ovi.connector 1.0

Rectangle {
    id: main
    color:"#eff0f1"

    property string placeTitleText
    property string placeAddressText

    property QtObject objectData:
        QtObject{
        //property string caption:""
        property string description:""
        property string icon:""
        property string url:""
    }

    Flickable{
        id:flick
        width:main.width
        height:main.height
        contentHeight: content.height
        boundsBehavior: "StopAtBounds"

        clip:true

        Column {
            id: content
            height: headerArea.height + headerSeperator.height + contentArea.height + spacingElement.height + 16
            width: main.width

            Rectangle {
                id: headerArea
                color: "#e3e4e6"
                height: 86
                width: parent.width

                Rectangle {
                    id: header;
                    color: "black"
                    height: 85
                    clip: true
                    anchors {
                        left: parent.left
                        right: parent.right
                    }

                    Rectangle {
//                        smooth: true
//                        radius: 10

                        color: "#e3e4e6"
                        height: 85 + 10;
                        anchors {
                            left: parent.left
                            right: parent.right
                        }

                        Rectangle {
                            id: headerImageArea
                            width: 86
                            height: 86
                            color:"#e3e4e6"
                            anchors.left: parent.left
                            anchors.verticalCenter: parent.verticalCenter
                            Image{
                                id:providerImage
                                anchors.centerIn: parent
                                source: objectData.icon
                            }
                        }
                        Rectangle{
                            id: headerTextArea
                            anchors {
                                left: headerImageArea.right
                                right:  parent.right
                                verticalCenter: parent.verticalCenter
                            }

                            MapsText {
                                id: headerText
                                objectName: "reviewGuideTitleText"
                                state: "listLarge"
                                font.weight: Font.Bold
                                text: placeTitleText
                                anchors {
                                    verticalCenter: parent.verticalCenter
                                    verticalCenterOffset: - (headerSubText.height + headerText.height)/4
                                    left: parent.left
                                    right: parent.right
                                }
                            }
                            MapsText {
                                id: headerSubText
                                state: "listSmallLight"
                                anchors.top: headerText.bottom
                                font.weight: Font.Bold
                                text: placeAddressText
                                anchors {
                                    left: parent.left
                                    right: parent.right
                                }
                            }
                        }
                    }
                }
            }

            Rectangle{
                id: headerSeperator
                height: 1
                width: main.width
                color: "#cdcecf"
            }

            Rectangle{
                id: spacingElement
                height: 15
                width: main.width
                color: "#eff0f1"
            }

            Rectangle{
                id: contentArea
                color: "#eff0f1"
                height: contentText.paintedHeight
                width: parent.width -30
                x: 15
                MapsText {
                    id: contentText
                    width:main.width-30
                    wrapMode: Text.WordWrap
                    text: objectData.description
                    textFormat: Text.RichText
                }
            }

        }

    }
}
