import QtQuick 1.0

import com.nokia.meego 1.0

Rectangle {
    id: reviewGuideList

    property alias model: list.model
    property variant reviewGuideDetails
    property Item mainPage
    property string headerCaption
    property string _placeTitleText
    property string _placeAddressText
    color: "#00000000"

    property Component delegate: ReviewGuideDelegate {
        id: reviewGuideDelegate
        width:reviewGuideList.width;
        objectName: reviewGuideList.objectName + "_" + index;

        MouseArea {
            anchors.fill: parent
            onClicked:{
                reviewGuideDetails = list.model.get(index);
                mainPage.pageStack.push(reviewGuideDetailsFactor);
            }
            onPressed:  { parent.color = "#d0d1d2" }
            onReleased: { parent.color = "#f0f1f2" }
            onCanceled: { parent.color = "#f0f1f2" }
        }
    }

    height: _tempColumn.height


    Column {
        id: _tempColumn

        PlaceCommonListHeader {
            //objectName: "placeDetailsSubReviews"
            width: reviewGuideList.width
            title: headerCaption
            topMost: true
            visible: list.count>0
        }

        Repeater {
            id: list
            delegate: reviewGuideList.delegate
        }
    }

    Component {
        id: reviewGuideDetailsFactor
        Page {
            parent: mainPage
            objectName: "reviewGuideDetailsPage"
            tools: ToolBarLayout {
                ToolIcon { objectName: "toolBarIconBackButton"; iconId: "icon-m-toolbar-back"; onClicked: { mainPage.pageStack.pop(); }}
                ToolButton {
                    objectName: "buttonMoreGuideReviews"
                    text: qsTranslate("Maps", "qtn_placesconnector_viewer_reviews_more")
                    onClicked: Qt.openUrlExternally(reviewGuideDetails.url)
                    visible: !!reviewGuideDetails.url
                    anchors.centerIn: parent
                }

                //icon-m-toolbar-view-menu is not functional at the moment
                //ToolIcon { iconId: "icon-m-toolbar-view-menu"; }
            }
            ReviewGuideDetails {
                objectData: reviewGuideDetails
                placeTitleText: _placeTitleText
                placeAddressText: _placeAddressText
                anchors.fill: parent
            }
        }
    }
}
