import QtQuick 1.0

import com.nokia.meego 1.0

import ".."

Page {
    id: subCatPage

    tools: categoryTreeId.tools
    property variant category
    property variant categoryName: ""
    property string categoryId: "-1"

    signal nextCategoryClicked(int index)
    signal catPlaceClicked(variant place, variant list)

    anchors.fill: parent

    onStatusChanged: {
        if (status === PageStatus.Active) {
            catList.putResultsOnMap();
        } else if (status == PageStatus.Inactive) {
        }
    }

    PlacesConnectedList {
        id: placesList

        onQueryFinished: {
            catList.fillResultList(model, categoryName);
        }

        onItemUpdated: {
            catList.putResultsOnMap();
        }
        onModelUpdated: {
            catList.putResultsOnMap();
        }
    }

    CategoryList {
        id: catList

        anchors.fill: parent
        currentCategory: category
        headerName: categoryName
        onSubCategoryClicked: {
            nextCategoryClicked(index);
        }
        onCategoryPlaceSelected: {
            catPlaceClicked(placesList.get(index), placesList);
        }
        onRefreshed: {
            placesList.clear();
            placesList.query({
                 searchCategory: categoryId,
                 //searchTerm: categoryName,
                 location: location,
                 parent: catList
            });
        }
    }

    function fillListWithCategoryInfo(aInfo) {
        if (aInfo.lastLeaf) {
            catList.showLoadingResults(aInfo.name);
        } else {
            catList.fillCategoryList(aInfo.category);
        }
    }

    function clear() {
        catList.removeResultsFromMap();
    }
}
