import QtQuick 1.0

import com.nokia.meego 1.0

TextField {
    inputMethodHints: Qt.ImhNoPredictiveText
    cursorPosition: 0

    property bool withDefaultValue: text == defaultValue || !text

    property string defaultValue
    property color defaultValueColor: "#B9B9BA"
    property color actualValueColor: "#000000"

    onActiveFocusChanged: {
        if (!activeFocus && text == "") {
            platformStyle.textColor = defaultValueColor;
            cursorPosition = 0;
            text = defaultValue;
        } else if (activeFocus && text == defaultValue) {
            platformStyle.textColor = actualValueColor;
            cursorPosition = 0;
            text = "";
        }
    }
    onTextChanged: {
        if (text == defaultValue || !text) {
            platformStyle.textColor = defaultValueColor;
            if (!text && !activeFocus) {
                text = defaultValue;
            }
        } else {
            platformStyle.textColor = actualValueColor;
        }
    }
    Component.onCompleted: {
        if (!text) {
            platformStyle.textColor = defaultValueColor;
            cursorPosition = 0;
            text = defaultValue;
        } else {
            platformStyle.textColor = actualValueColor;
        }
    }
}
