import QtQuick 1.0
import ovi.connector.places 1.0

// Create the viewer
PlacesViewer {
    property variant mapsApp

    property variant currentPlace
    Component {
        id: factory
        Place {}
    }

    function _cloneDestination(destination) {
        if (currentPlace) {
            currentPlace.destroy();
        }

        currentPlace = factory.createObject(mainscreen);
        currentPlace.uri = destination.uri;
        currentPlace.properties = JSON.parse(JSON.stringify(destination.properties));
        currentPlace.details = JSON.parse(JSON.stringify(destination.details));
    }

    function doNavigateTo(destination) {
        _cloneDestination(destination);

        while(tabGroup.currentTab.depth > 1) {
            tabGroup.currentTab.pop(null, true);
        }
        while(directionsStack.depth > 1) {
            directionsStack.pop(null, true);
        }

        directionsStack.currentPage.routeTo(currentPlace);
        directionsTabBtn.clicked();
    }
}
