import QtQuick 1.0

import com.nokia.meego 1.0

import ovi.connector 1.0

Item {
    property alias heading: title.text
    property alias value: numbers.text

    state: "normal"

    anchors {
        left: parent.left
        right: parent.right
    }
    height: title.height + numbers.height

    MapsText {
        id: title
        platformStyle: LabelStyle { fontPixelSize: 18 }
        font.weight: Font.Light
    }

    MapsText {
        id: numbers
    }

    states: [
        State {
            name: "small"
            PropertyChanges {
                target: numbers.platformStyle
                fontPixelSize: 18
            }
            AnchorChanges {
                target: numbers
                anchors.top: undefined
                anchors.left: title.right
            }
            PropertyChanges {
                target: numbers
                width: parent.width - (title.x + title.width)
            }
        },
        State {
            name: "normal"
            PropertyChanges {
                target: title
                width: parent.width
            }
            PropertyChanges {
                target: numbers
                width: parent.width
            }
            PropertyChanges {
                target: numbers.platformStyle
                fontPixelSize: 24
            }
            AnchorChanges {
                target: numbers
                anchors.top: title.bottom
                anchors.left: undefined
            }
        }

    ]
}
