var cancelRequest = false;
var xhr = new XMLHttpRequest();
var environment = {
    "it": {
        "uri": "http://cpqit.nokia.com/api.php?",
        "name": "Ovi Maps QML",
        "id": "6031",
        "version": "PR1.0"
    },
    "qa": {
        "uri": "http://cpqqa.nokia.com/api.php?",
        "name": "Ovi Maps QML",
        "id": "2306",
        "version": "PR1.0"
    },
    "prd": {
        "uri": "http://cpq.nokia.com/api.php?",
        "name": "Ovi Maps QML",
        "id": "2008",
        "version": "PR1.2"
    }
}

function _onSuccess() {
    feedbackScene.successfulSubmit = true;
    feedbackScene.feedbackState = feedbackScene.state_submitSuccess;
    reportSubmitted();
}
function _onFail() {
    feedbackScene.successfulSubmit = false;
    feedbackScene.feedbackState = feedbackScene.state_submitFail;
    if(xhr) {
        xhr.abort();
    }
}

function cancel() {
    if(xhr) {
        cancelRequest = true;
        xhr.abort();

        feedbackScene.successfulSubmit = false;
        feedbackScene.feedbackState = feedbackScene.state_idle;
    }
}

function submitReport(env, npsForm, deviceInfo, networkInfo, generalInfo) {
    // Build report parameters
    var params = {};
    var type = environment[env] ? environment[env] : environment.qa;

    type.sourceID = npsToken;  // assign token

    params.projid = type.id;
    params.version = type.version;
    params.pageurl = type.name;
    params.rec = npsForm.score;
    params.sourceId = type.sourceId;
    params.sw = appState.mapsVersion;
    params.survey_language = locale;
    if (npsForm.comments) {
        params["fb-text"] = npsForm.comments;
    }
    if (npsForm.emailAddress) {
        params["fb-email"] = npsForm.emailAddress;
    }
    // Device information
    if(deviceInfo) {
        params.device = deviceInfo.productName;
        params.hw = deviceInfo.model;
        params.imei = deviceInfo.imei;
    }
    if(generalInfo) {
        params.country = generalInfo.currentCountryCode;
    }
    if(networkInfo) {
        params.operator = networkInfo.currentMobileNetworkCode;
    }


//    params.nokia_account = "oviaccount";
//    if (npsForm.useEmail) {
//        params.fb_email = "email@ovi.com";
//    }

    postNpsReport(type.uri, params,
                function() {
                      log.trace("NPS report sent ok.")
                      _onSuccess();
                },
                function(reason) {
                    log.trace("Failed to send NPS report.")
                      _onFail();
                });
}


// Sends report to NPS server
// opts: report parameters
// callback: callback function on succuss
// errback: callback function on error
function postNpsReport(uri, opts, callback, errback) {
    var mark = (new Date()).valueOf();
    var options = opts || {};
    var path = uri + _optionString(options);


    log.trace("NPS: " + path);
    //var xhr = new XMLHttpRequest();
    xhr = new XMLHttpRequest();
    xhr.open('POST', path, true);
    var headers = options.headers || {};
    for (var key in headers) {
        var value = headers[key];
        if (value) xhr.setRequestHeader(key, value);
    }

    xhr.onreadystatechange = function() {
        if (xhr.readyState === 4) {
            var now = (new Date()).valueOf();
            log.trace("NPS: run-time=" + (now-mark) + "ms");
            var status = xhr.status;
            var resp = xhr.responseText;
            log.trace("NPS: response: " + resp);
            if (status === 200 && resp.indexOf("ERROR") === -1) {
                if(callback) callback(resp);
            } else if (errback) {
                log.trace("error status=" + status + "-" + xhr.statusText);
                if(errback) errback(status);
            }
        }
    };
    xhr.send(null);
}

// Internal helper function
function _optionString(options) {
    var keys = [];
    for (var key in options) {
        keys.push(key);
    }
    //keys.sort();

    var opts = [];
    for (var i = 0; i < keys.length; i++) {
        var key = keys[i];
        var val = options[key];
        opts.push(key + "=" + encodeURIComponent(val))
    }

    return (opts.length)? opts.join("&") : "";
}

