import QtQuick 1.0

import com.nokia.meego 1.0

Rectangle {
    id: loggingScreen

    width: parent.width;
    height: parent.height

    ScrollDecorator {
        flickableItem: flickArea
    }

    Flickable {
        id: flickArea

        anchors.fill: parent
        contentWidth: parent.width;
        contentHeight: dataColumn.childrenRect.height + 4*dataColumn.anchors.margins
        clip: true

        Column {
            id: dataColumn

            spacing: 10
            anchors.fill: parent
            anchors.leftMargin: 10

            Label {
                text: "<h2>Logging settings</h2>"
            }

            Column {
                spacing: 10;

                Label {
                    text: "Loglevel"
                }

                ButtonColumn {
                    id: loglvl

                    onCheckedButtonChanged: {
                        log.info("Changed settings loglevel to "+checkedButton.identifier)
                        appSettings.setValue("loglevel", checkedButton.identifier)
                        log.setLogLevel(checkedButton.identifier)
                    }

                    RadioButton {
                        id: lvltrace
                        property string identifier: "4"
                        Text { text: "everything"; anchors.left: parent.right; }
                    }
                    RadioButton {
                        id: lvlinfo
                        property string identifier: "3"
                        Text { text: "info"; anchors.left: parent.right; }
                    }
                    RadioButton {
                        id: lvlwarn
                        property string identifier: "2"
                        Text { text: "warnings and errors"; anchors.left: parent.right; }
                    }
                    RadioButton {
                        id: lvlerror
                        property string identifier: "1"
                        Text { text: "errors only"; anchors.left: parent.right; }
                    }

                }

            }          
        }
    }

    Component.onCompleted: {
        log.info("loading logging settings done")

        log.info("logging level: "+ log.getLogLevel());
        var lvl = log.getLogLevel();
        if( lvl == lvltrace.identifier)
            loglvl.checkedButton = lvltrace
        if(lvl == lvlinfo.identifier)
            loglvl.checkedButton = lvlinfo
        if(lvl == lvlwarn.identifier)
            loglvl.checkedButton = lvlwarn
        if(lvl == lvlerror.identifier)
            loglvl.checkedButton = lvlerror

    }
}
