import QtQuick 1.0

import com.nokia.meego 1.0
import com.nokia.extras 1.0

import ovi.connector.places 1.0

PlacesPicker {
    id: picker

    visible: true

    function resetSearch(searchTerm) {
        picker.prefilledString = "";
        picker.prefilledString = searchTerm;
    }

    function showSearch(searchTerm) {
        picker.prefilledString = searchTerm;
    }

    onPicked: {
        picker.pageStack.push(viewComponent);
    }

    onStatusChanged:  {
        if (status == PageStatus.Activating) {
            if (picker.__map) {
                var mapModelObjectOwners = picker.__map.model.getObjectsOwners();
                if (picker.__map.model.count == 0 || picker.__map.model.checkForOwner("nearby") || picker.__map.model.checkForOwner("categories") || picker.__map.model.checkForOwner("favorites") || picker.__map.model.checkForOwner("__PURE_DELETE__")) {
                    picker.clearModel();
                    picker.mapFocus = true;
                }
            }
        }
    }
}

