import QtQuick 1.0

import com.nokia.meego 1.0 as QtComponents

import MapsPlugin 1.0

Item {
    id: _tmpWindow

    Rectangle {
        id : searchInputBg
        anchors.top: parent.top

        width: parent.width
        height: 85
        color: "black"

        clip: true

        Rectangle {
            width : parent.width
            height : 85 + 10
            color : "#f0f0f0"
//            radius: 10
//            smooth: true

            // Fake Search Component - uncomment if needed
            /*
            QtComponents.TextField {
                 anchors.leftMargin : 16
                 anchors.verticalCenter: parent.verticalCenter
                 anchors.left: parent.left
                 anchors.right :parent.right
                 anchors.rightMargin : 20
                 width: parent.width - 20;
            }
            */
        }
    }

    Rectangle {
        id: si
        anchors.top : searchInputBg.bottom

        height: 4
        width: parent.width
        gradient: Gradient {
         GradientStop { position: 0.0; color: "black" }
         GradientStop { position: 1.0; color: "transparent" }
        }
        opacity: 0.5
        z: 1
    }

    property variant __tb: tb
    QtComponents.ToolBar {
        id: tb
        anchors.bottom: _tmpWindow.bottom
        tools: QtComponents.ToolBarLayout {
            id: commonTools
            height: placesTabBtn.height

            QtComponents.ToolIcon {
                iconId: "icon-m-toolbar-back"
                objectName: "backTabBtn"
                opacity: 0.4
            }
            QtComponents.ButtonRow {
                QtComponents.TabButton {
                    id: placesTabBtn
                    objectName: "placesTabBtn"
                    tab: QtComponents.PageStack { }
                    Image {
                        anchors.centerIn: parent
                       source: "../images/icon_findplaces.png"
                    }
                }
                QtComponents.TabButton {
                    id: nearbyTabBtn
                    objectName: "nearbyTabBtn"
                    tab: QtComponents.PageStack { }
                    Image {
                        anchors.centerIn: parent
                        source: "../images/icon_aroundme.png"
                    }
                }
                QtComponents.TabButton {
                    id: directionsTabBtn
                    objectName: "directionsTabBtn"
                    tab: QtComponents.PageStack { }
                    Image {
                        anchors.centerIn: parent
                        source: "../images/icon_directions.png"
                    }
                }
                QtComponents.TabButton {
                    id: moreTabBtn
                    objectName: "moreTabBtn"
                    tab: QtComponents.PageStack { }
                    Image {
                        anchors.centerIn: parent
                        source: "../images/icon_more.png"
                    }
                }
            }
       }
    }

    Map {
        id: map
        deviceOrientationMode: main.inPortrait ? Map.PORTRAIT : Map.LANDSCAPE
        anchors { top: searchInputBg.bottom; left: parent.left; right: parent.right; bottom: tb.top }

        Component.onCompleted: {
            if (appState.ssoEnabled) {
                map.automaticPanning = false;
                map.automaticRotating = false;
                map.automaticZooming = false;
            }
            map.restoreState("MapsMain");
        }
    }
 }
